function conjunto_gui(pregunta, b, h, r, Nd, Mxd, Myd, Ai, Asup, Adch)


clf;
fck=25;
fyk=500;
fcd=fck/1.5;
fyd=fyk/1.15;
Es=2.0*10^5;

if pregunta==1;
%     tic
    esviada_comprobar_v11()
    clc
     close('Opcion_1');
%     fprintf('Armado ptimo\n')
% display(Matriz_optimizacion)
% 
 Aoptima=2*((Matriz_optimizacion(1,1)*pi*((Matriz_optimizacion(1,2)/2)^2))+(Matriz_optimizacion(1,4)*pi*((Matriz_optimizacion(1,5)/2)^2)))+2*((Matriz_optimizacion(3,4)*pi*((Matriz_optimizacion(3,5)/2)^2)));
% fprintf('rea (mm^2)');
% display(Aoptima)
 top3=text(0.65,1, 'rea ptima (mm^2)');
 top2=text(1.95,0.65,num2str(Aoptima),'HorizontalAlignment','center');
  sop2 = top2.FontSize;
  top2.FontSize = 16;
   sop3 = top3.FontSize;
  top3.FontSize = 12;
%-------------------
% toc

    return
end

if pregunta==2;
%     tic
    
    armado_simple_v3()
%    clc;
     close('Opcion_1');
    Asimple= area_simple2+area_simple1;

 top4=text(0.65,1, 'Matriz simple (mm^2)');
 top5=text(1.95,0.65,num2str(Asimple),'HorizontalAlignment','center');
  sop5 = top5.FontSize;
  top5.FontSize = 16;
   sop4 = top4.FontSize;
  top4.FontSize = 12;

%  toc
    return
   end
 
 
%--------------------------------------------------------------------------
function esviada_comprobar_v11
%programa que me va a decir si Mxmax<Mxd ||while Mymax<Myd entonces aumentar el area superior
%y el area lateral en un valor para volver a sacar los parametros
%optimizados y comprobar de nuevo si cumple, si no cumple realizar de nuevo
%la iteracion, si Mxd>Myd entonces Asup=Asup+10, si Myd>Mxd entonces Adch=Adch+10
%-------------------------------------------------------------------------------

%Llamada a las funciones de las distintas armaduras
armadura_sup()

%Armadura superior - Armadura inferior-------------------------------------

function armadura_sup
%La armadura superior e inferior son iguales

%Parmetros--------------------
 

%x(1)=diametro 1, x(2)=diametro 2, x(3)=n de redondos de diametro 2
%lb = [6 6 1]; %limites inferiores de x(1), x(2) y x(3)
%ub = [40 40 20]; %limites superiores de x(1), x(2) y x(3)

% Como cada conjunto de valores de los diametros tienen 10 miembros
%se debe discretizar en un rango de variables [1 10], por lo que
%los nuevos limites inferiores y superiores quedan de la siguiente forma
lb = [1 1 1 1 1]; %limites inferiores de x(1), x(2), x(3), x(4) y x(5)
ub = [10 10 20 20 10]; %limites superiores de x(1), x(2), x(3), x(4) y x(5)
%el limite superior de x(3) determina hasta el n max de redondos a poner

function x = valores_posibles(x)
%Esta funcin crea las variables de los diametrox x(1) y x(2) definiendo 
%sus posibles valores

% Posibles valores para el diametro 1 x(1), diamatro 2 x(2) y diametro 4
% x(4)
diam1 = [6 8 10 12 14 16 20 25 32 40]; 
diam2 = [6 8 10 12 14 16 20 25 32 40];
diam5 = [6 8 10 12 14 16 20 25 32 40];
%n_red=1:1:10; puedo crear una variable que determine hasta que n de
%redondos quiero poner

% Discretiza valores, es decir, cada variable elige su valor a partir del
% vector dado
x(1) = diam1(x(1));
x(2) = diam2(x(2));
x(5) = diam5(x(5));
%x(3)=n_red(x(3)); si actuar ka variable en relacion al n max deseado
end

function [c, ceq] = restricciones(x)
%Esta funcion calcula los constraints/restricciones del problema, 
%es decir, son ecuaciones adicionales del problema

smin1 =x(1); %mnima separacin horizontal entre barras
smin2 =x(1); %mnima separacin vertical entre barras

%EJEMPLO RESTRICCIONES
%c(1)=2*x(1)-diametro_1_sup;  %diametro_sup_extremos>=2*diametro_lateral 
%c(1)=diametro_1_sup-2*x(1);  %2*x(1)>=diametro_sup_extremos
%--------------------------------------------------------------------
%restricciones armado superior
c(1)=(1.2501*x(2))-x(1);  %1.2501*diametro_2> diametro1
% c(1)=1.0*x(2)-x(1);
% c(2)=1.0*x(5)-x(1);
c(2)=smin1-((b-2*r-2*(x(1))-(x(3))*(x(2)))/((x(3)+1))); %separacion entre barras > 20
c(3)=(2*Asup+2*Adch)-2*(2*pi*(((x(1))/2)^2)+(x(3)*pi*(((x(2))/2)^2))+(x(4)*pi*(((x(5))/2)^2))); %Atotal=(2*Asup)+(2*Adch);

%restricciones armado lateral
c(4)=smin2-((h-2*r-(2*x(1))-(x(4))*(x(5)))/((x(4)+1))); 
%separacion entre barras > 20
%c(5)=x(2)-1.0*x(5);
% c(5)=x(2)-(1.2501*x(5)); %1.2501*diametro_5> diametro1 (mayor tiempo computacional)

ceq = []; %matriz ceq
end

function a = area(x)
%Funcin que determina el valor del area a partir de las 3 variables

a=2*(2*(pi*((x(1)/2)^2)))+(x(3)*(pi*(x(2)/2)^2))+2*((x(4)*(pi*(x(5)/2)^2))); %area a obtener
end

function a = variables_discretiza(x)

x = valores_posibles(x);% Map de variables discretas

a = area(x); % Area a partir de las variables
end

function [c, ceq] = restricciones_discretiza(x)
%funcion de la matriz de las restricciones

x = valores_posibles(x); % Map variables discretas

[c, ceq] = restricciones(x); %evaluacin de las restricciones
end

%[xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,n de variables, [], [], [], [], lb, ub, @restricciones_discretiza, n de variables que no poseen parametros a elegir, opts);
[xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,5, [], [], [], [], lb, ub, @restricciones_discretiza, 1:5);
% area_obtenida_total_optimizacion=fbestDisc;
xbestDisc = valores_posibles(xbestDisc);%hago la llamda para obtener los diametros
%dentro de los posible valores especificados
diametro_1_sup=xbestDisc(1);
diametro_2_sup=xbestDisc(2);
numero_redondos_diametro2_sup=xbestDisc(3);
%dentro de los posible valores especificados
diametro_1_dch=xbestDisc(5);
numero_redondos_diametro1_dch=xbestDisc(4);
separacion_barras_dch=(h-2*r-(2*diametro_1_sup)-(numero_redondos_diametro1_dch*diametro_1_dch))/((numero_redondos_diametro1_dch+1));
separacion_barras_sup=(b-2*r-2*(diametro_1_sup)-(numero_redondos_diametro2_sup)*(diametro_2_sup))/((numero_redondos_diametro2_sup+1));
%display(xbestDisc);
l_ancho_min=2*diametro_1_sup+numero_redondos_diametro2_sup*diametro_2_sup+2*r+separacion_barras_sup*(numero_redondos_diametro2_sup-1);
l_canto_min=2*diametro_1_sup+numero_redondos_diametro1_dch*diametro_1_dch+2*r+separacion_barras_dch*(numero_redondos_diametro1_dch-1);

if l_ancho_min>b | l_canto_min>h
    fprintf('Medidas incompatibles para el dimensionamiento de los esfuerzos introducidos,\nvuelve a ejecutar el programa con unas medidas:\n')
    fprintf('Ancho\n')
    BA=sprintf('%f > %f',b,l_ancho_min); %devuelve los valores como una cadena (sprinf)
    disp(BA)
    HC=sprintf('%f > %f',h,l_canto_min); %devuelve los valores como una cadena (sprinf)
    fprintf('Canto\n')
    disp(HC)
    fprintf('\nVuelve a ejecutar el programa con otras medidas')
   return
end

end

%Impresin por pantalla de los datos---------------------------------------
%sobreescribo el area Ai del principio por el nuevo area Ai hallada

fprintf('Ai=[N redondos diametro1 Diametro1 Recubrimiento N redondos diametro2 Diametro2')
numero_redondos_diametro1_sup=2;numero_redondos_diametro1_inf=2;
numero_redondos_diametro2_dch=0;numero_redondos_diametro2_izq=0;

Ai=[[numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
    [numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
    [numero_redondos_diametro2_dch 0 r numero_redondos_diametro1_dch diametro_1_dch ]
    [numero_redondos_diametro2_dch 0 r numero_redondos_diametro1_dch diametro_1_dch ]
]
Matriz_optimizacion=Ai;

%------------------------------------------------------------------------

acero=armadura();
%seccion(0.5,b/2+b/5,h/2+h/10);

[Li,Wi]=integraHammer(); % integracion de Hammer
[n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
[nodos,eltos]=discretiza(); % discretizacion area bruta
 
emax=ecu2;

options = optimoptions('fsolve','Display','off');
s0=[0 0 0];
s=fsolve(@(s)calcula(s),s0,options);

vv=esfuerzos(s);
Mxmax=vv(1);
Mymax=vv(2);

 if Mxmax>=Mxd & Mymax>=Myd
     fprintf('\nMxmax=>Mxd -> ')
     X = sprintf('%f => %f',Mxmax,Mxd); %devuelve los valores como una cadena (sprinf)
      %a partir de %f convirte los valores de coma flotante en punto fijo
      disp(X)
      fprintf('\nMymax=>Myd -> ')
      Y= sprintf('%f => %f',Mymax,Myd); %devuelve los valores como una cadena (sprinf)
      %a partir de %f convirte los valores de coma flotante en punto fijo
      disp(Y)
      disp("Cumple con los requisitos dados")
%       figure('Name','Dimensionado seccin','NumberTitle','off');
      seccion(0.5,b/2+b/5,h/2+h/10);
 else
        disp("No Cumple con los requisitos dados") 
      end

    function [Li,Wi]=integraHammer()
        % metode de integracion de Hammer eltos triangulares
        
        Li=1/2*[
            [1 1 0]
            [1 0 1]
            [0 1 1]
            ]; % coordenadas
        Wi=1/6*[1 1 1]; % pesos        
        
    end        

    function [n,ec2,ecu2]=initHormigon(fck)
        % diagrama parabola-rectangulo
        
        if(fck<50)
            n=2;
            ec2=2/1000;
            ecu2=3.5/1000;
        else
            n=1.4+23.4*((90-fck)/100)^4;
            ec2=(2.0+0.085*(fck-50)^0.53)/1000;
            ecu2=(2.6+35*((90-fck)/100)^4)/1000;            
        end
        
    end

    function [nodos,eltos]=discretiza()
        % discretizacion
        x0=-b/2:b/10:b/2;
        y0=-h/2:h/10:h/2;

        [X,Y] = meshgrid(x0,y0);

        nx=size(x0);
        nx=nx(2);
        x=reshape(X,nx^2,1);

        ny=size(y0);
        ny=ny(2);
        y=reshape(Y,ny^2,1);
        DT=delaunayTriangulation(x,y); % triangulacion de Delaunay
%         figure;
%         triplot(DT)

        nodos=DT.Points; % nodos
        eltos=DT.ConnectivityList; % elementos
                
    end

    function v=defLong(x,y,s)        
        % plano de deformacion
        % (x,y): coordenadas en la seccion
        % e0: deformacion axial
        % ax: giro en torno al eje x
        % ay: giro en torno al eje y
        
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=e0+ay*x+ax*y;        
    end

    function v=tensionHormigon(x,y,s)
        % tension en el Hormigon
        v=0;
        
        ec=defLong(x,y,s);
        if((ec>0)&&(ec<=ec2))
            v=fcd*(1-(1-ec/ec2)^n);            
        elseif(ec>ec2)
            v=fcd;            
        end
                    
    end

    function v=tensionAcero(x,y,s)
        % tension en el Acero
        v=0;
        
        ec=defLong(x,y,s);
        if(ec<-fyd/Es)
            v=-fyd;
        elseif(-fyd/Es<ec)&&(ec<fyd/Es)
            v=Es*ec;
        else
            v=fyd;
        end
                    
    end

    function v0=calcula(s)
        % calcula e0 para Nd
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=zeros(1,3);
        x=0;
        y=0;
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            vJ=calculaJ(nk);
            v0=intHammer(nk,s);
            v=v+v0*vJ;
        end        
        
        % aportacion del acero
        n0=size(acero);
        n0=n0(1); % numero de armaduras, me dice el n de redondos que tengo,
        %da igual que columna coger, porque al final cada fila posee sus
        %datos, y el n final de redondos es el n de filas
        for k=1:n0
            x=acero(k,1); %determina la posicin x de cada redondo (k=fila, 1=columna)
            y=acero(k,2); %determina la posicin y de cada redondo
            d=acero(k,3); %determina el diametro de cada redondo
            A=pi*(d/2)^2; % area que implica cada redondo
            ts=tensionAcero(x,y,s); %la tensin del acero viene dada por una funcin
            %que determina su tensin dependiendo de su deformacin
            v=v+A*ts*[1 y x]; %vector que determina los esfuerzos
        end %end del bucle for
        
        v(1)=v(1)/1000; % axil (kN)
        v(2)=v(2)/10^6;% flector Mx (kNm)
        v(3)=v(3)/10^6; % flector My (kNm)
        
        v0=zeros(1,2);
        v0(1)=v(1)-Nd;
        
        v1=ecmax(s);                 
        v0(2)=v1-emax;
        
        v0(3)=v(3)-Myd;
        
    end %end de la funcion calcula(s)

    function v0=esfuerzos(s)
        % (Nc,Mc): esfuerzos en el hormign
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=zeros(1,3);
        x=0;
        y=0;
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            vJ=calculaJ(nk);
            v0=intHammer(nk,s);
            v=v+v0*vJ;
        end 
        
        % aportacion del acero
        n0=size(acero);
        n0=n0(1); % numero de armaduras
        for k=1:n0
            x=acero(k,1);
            y=acero(k,2);
            d=acero(k,3);
            A=pi*(d/2)^2; % area
            ts=tensionAcero(x,y,s);
            v=v+A*ts*[1 y x];
        end
        
        v(1)=v(1)/1000; % axil (kN)
        v(2)=v(2)/10^6; % flector Mx (kNm)
        v(3)=v(3)/10^6; % flector My (kNm)
        
        v0=[v(2) v(3)];
        
    end %end de la funcion esfuerzos(s)

    function v0=ecmax(s)
        % deformacion maxima en el hormigon
         
        v0=0;       
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            for j=1:3
                x=nk(j,1);
                y=nk(j,2);
                v0=max(v0,defLong(x,y,s));
            end
        end                
    end

    function vJ=calculaJ(nk)
        % calcula el jacobiano
        % vk: elemento k
        % nk: nodos del elemento k
        vJ=zeros(2);
        vJ(1,1)=[1 0 -1]*nk(:,1);
        vJ(1,2)=[1 0 -1]*nk(:,2);
        
        vJ(2,1)=[0 1 -1]*nk(:,1);
        vJ(2,2)=[0 1 -1]*nk(:,2);
        
        vJ=det(vJ);              
                       
    end

    function v=intHammer(nk,s)
        % coordenadas (x,y) a partir de (L1,L2,L3)
        v=zeros(1,3);    
        for i=1:3
                Lj=Li(i,:);
                x=Lj*nk(:,1);
                y=Lj*nk(:,2);
                v=v+Wi(i)*tensionHormigon(x,y,s)*[1 y x];
        end                
    end      

%-----------------------------------
    function v=armadura()
       
next=sum(Ai(:,1)); %calcula la suma de los redondos en los extremos
ncen=sum(Ai(:,4)); %calcula la suma de los redondos intermedios
na=next+ncen; %suma total de todos los redondos
v=zeros(na,3); %matriz de ceros de 3 columnas y na filas, 
%siendo la matriz v=[pos.x pos.y diametro]

%---------------------------
i=1; %armadura superior
ni=Ai(i,1); %n redondos en la armadura superior en los extremos
nc=Ai(i,4); %n redondos intermedios en la armadura superior
nt=ni+nc;
di=Ai(i,2); %diametro de los redondos en los extremos
dc=Ai(i,5); %diametro de los redondos intermedios
ri=Ai(i,3); %recubrimiento
da=(b-2*r-2*(di)-(nc)*(dc))/((nc+1));
k=1;l=0;
v(k,:)=[(b/2)-ri-(di/2) (h/2)-ri-(di/2) di];
v(ni+nc,:)=[v(k,1)-(b-2*r-di) h/2-ri-(di/2) di];
% for j=2:ni+nc-1
%      v(k+j-1,:)=[v(k+j-2,1)-((di/2)+(dc/2)+da) h/2-ri dc] 
%      l=l+1;
% end

if nt==3
    v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) h/2-ri-(di/2) dc];
    %v(ni+nc,:)=[v(k,1)-(b-2*r-di) h/2-ri di];
else if nt>3
    v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) h/2-ri-(di/2) dc];
    for j=3:ni+nc-1 
    v(k+j-1,:)=[v(k+j-2,1)-(dc+da) h/2-ri-(di/2) dc]; %si tengo ms de 1 redondo intermedio
%la ecuacin del posicionamiento vara
l=l+1
    end
    end
end
k=nt+1;
%---------------------------

i=2; % armadura inferior

ni=Ai(i,1); %n redondos en la armadura inferior en los extremos
nc=Ai(i,4); %n redondos intermedios en la armadura inferior
nt=ni+nc;
di=Ai(i,2); %diametro de los redondos en los extremos
dc=Ai(i,5); %diametro de los redondos intermedios
ri=Ai(i,3); %recubrimiento
da=(b-2*r-2*(di)-(nc)*(dc))/((nc+1));
k=nt+1;l=0;
v(k,:)=[(b/2)-ri-(di/2) (-h/2)+ri+(di/2) di];
v(nt+ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri+(di/2) di];
% for j=2:ni+nc-1
%      v(k+j-1,:)=[v(k+j-2,1)-((di/2)+(dc/2)+da) h/2-ri dc] 
%      l=l+1;
% end

if nt==3
    v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) -h/2+ri+(di/2) dc];
   % v(ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];
else if nt>3
    v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) -h/2+ri+(di/2) dc];
    for j=3:ni+nc-1 
    v(k+j-1,:)=[v(k+j-2,1)-(dc+da) -h/2+ri+(di/2) dc]; %si tengo ms de 1 redondo intermedio
%la ecuacin del posicionamiento vara
l=l+1
    end
    end
end
k=nt+1;

%---------------------------

i=3; % armadura derecha

ni=Ai(i,4); %n redondos en la armadura derecha
nsup=Ai(1,1); %n redondos extremos superiores
nl=ni+nsup; %nde redondos lateral
di=Ai(i,5); %diametro de los redondos en lateral
dspex=Ai(1,2); %diametro redondos extremos superiores
dscn=Ai(1,5); %diametro redondos intermedios superiores
ri=Ai(i,3); %recubrimiento
da= (h-2*r-(2*dspex)-(ni)*(di))/((ni+1));
k=nt+nt+1;l=0;
v(k,:)=[(b/2)-ri-(dspex/2) (h/2)-(ri+dspex+da+(di/2)) di]; %(b/2)-ri-(di/2)
%v(nt+ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];

if nl==3
   v(k,:)=[(b/2)-ri-(dspex/2) (h/2)-(ri+dspex+da+(di/2)) di];
   % v(ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];
else if nl>3
    v(k,:)=[(b/2)-ri-(dspex/2) (h/2)-(ri+dspex+da+(di/2)) di];
    for j=2:nl-2 %nl-2 porque tengo 2 redondos en los extremos 
    v(k+j-1,:)=[(b/2)-ri-(dspex/2) v(k+j-2,2)-(di+da) di]; %si tengo ms de 1 redondo intermedio
%la ecuacin del posicionamiento vara
l=l+1;
    end
    end
end
k=nt+nt+1;

%---------------------------

i=4; % armadura izquierda

ni=Ai(i,4); %n redondos en la armadura izquierda
nsup=Ai(1,1); %n redondos extremos superiores
nl=ni+nsup; %nde redondos lateral
di=Ai(i,5); %diametro de los redondos en lateral
dspex=Ai(1,2); %diametro redondos extremos superiores
dscn=Ai(1,5); %diametro redondos intermetios superiores
ri=Ai(i,3); %recubrimiento
da= (h-2*r-(2*dspex)-(ni)*(di))/((ni+1));
k=nt+nt+ni+1;l=0;
v(k,:)=[(-b/2)+ri+(di/2) (h/2)-(ri+dspex+da+(di/2)) di];
%v(nt+ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];

if nl==3
   v(k,:)=[(-b/2)+ri+(dspex/2) (h/2)-(ri+dspex+da+(di/2)) di];
   % v(ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];
else if nl>3
    v(k,:)=[(-b/2)+ri+(dspex/2) (h/2)-(ri+dspex+da+(di/2)) di];
    for j=2:nl-2 %nl-2 porque tengo 2 redondos en los extremos 
    v(k+j-1,:)=[(-b/2)+ri+(dspex/2) v(k+j-2,2)-(di+da) di]; %si tengo ms de 1 redondo intermedio
%la ecuacin del posicionamiento vara
l=l+1;
    end
    end
end
k=nt+nt+ni+1;
    end

%--------------------------------

    function seccion(esc,x0,y0) %creo una seccin a escala 1:2
        % dibuja seccion
        H0=[[b/2 h/2]
            [-b/2 h/2]
            [-b/2 -h/2]
            [b/2 -h/2]
            ];
        H0(:,1)=H0(:,1)+x0;
        H0(:,2)=H0(:,2)+y0;
        H0=esc*H0;
        
        figure('Name','Armado ptimo','NumberTitle','off');
        line(H0(1:2,1),H0(1:2,2),'LineWidth',2);
        line(H0(2:3,1),H0(2:3,2),'LineWidth',2);
        line(H0(3:4,1),H0(3:4,2),'LineWidth',2);
        x=zeros(1,2);y=zeros(1,2);        
        x(1)=H0(1,1);x(2)=H0(4,1);
        y(1)=H0(1,2);y(2)=H0(4,2);
        line(x,y,'LineWidth',2);
        
        
        n0=size(acero); %tamao de la matriz acero
        n0=n0(1); %n de redondos que hay en la seccion
%          figure('Name','Armado ptimo','NumberTitle','off');

        suptitle('Armado ptimo')
        for i=1:n0
            a=acero(i,:); %cojo cada fila de la matriz v de la funcin acero=armadura
            di=a(3)/2; %el diametro es la columna 3 del vector a
            t=0:pi/30:2*pi; %creo los parametros de los crculos
            x=a(1)+di*cos(t); %x=posicin 1 (centro del redondo) del vector a en x + diametro*cos(t)
            y=a(2)+di*sin(t);
            x=x+x0;y=y+y0;
            x=esc*x;y=esc*y;
            hold on;
            
            subplot(1,2,1) %dibujo en la parte izq
            plot(x,y,'r','LineWidth',1.5);
%              title ('Armado ptimo')
            axis equal; %Utilice la misma longitud para las unidades de datos a lo largo de cada eje
        end       
                line(H0(1:2,1),H0(1:2,2),'LineWidth',2);
        line(H0(2:3,1),H0(2:3,2),'LineWidth',2);
        line(H0(3:4,1),H0(3:4,2),'LineWidth',2);
        x=zeros(1,2);y=zeros(1,2);        
        x(1)=H0(1,1);x(2)=H0(4,1);
        y(1)=H0(1,2);y(2)=H0(4,2);
        line(x,y,'LineWidth',2);
     
        
 subplot(1,2,2); 
 suptitle('Armado ptimo')
% %  title('Matriz armado ptimo')
 text(0,3,'Nred');
 text(0.9,3,'Diam');
 text(1.8,3,'r');
 text(2.10,3,'N red');
 text(3,3,'Diam');
 top1=text(2,2,num2str(Matriz_optimizacion),'HorizontalAlignment','center');
  sop1 = top1.FontSize;
 top1.FontSize = 16;

 line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4]);
 axis off tight
    end
%--------------------------------
while  Mxmax<=Mxd | Mymax<=Myd; 
    
 if Mxd>Myd
    Asup=Asup+1;
    Adch=Adch+2;
        
armadura_sup()

%Impresin por pantalla de los datos---------------------------------------
%sobreescribo el area Ai del principio por el nuevo area Ai hallada

fprintf('Ai=[N redondos diametro1 Diametro1 Recubrimiento N redondos diametro2 Diametro2')
numero_redondos_diametro1_sup=2;numero_redondos_diametro1_inf=2;
numero_redondos_diametro2_dch=0;numero_redondos_diametro2_izq=0;

Ai=[[numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
    [numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
    [numero_redondos_diametro2_dch 0 r numero_redondos_diametro1_dch diametro_1_dch ]
    [numero_redondos_diametro2_dch 0 r numero_redondos_diametro1_dch diametro_1_dch ]
]

Matriz_optimizacion=Ai;


acero=armadura();
%seccion(0.5,b/2+b/5,h/2+h/10);

[Li,Wi]=integraHammer(); % integracion de Hammer
[n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
[nodos,eltos]=discretiza(); % discretizacion area bruta
options = optimoptions('fsolve','Display','off');
s0=[0 0 0];
s=fsolve(@(s)calcula(s),s0,options);

vv=esfuerzos(s);
Mxmax=vv(1);
Mymax=vv(2);
if(Mxmax>Mxd) & Mymax>Myd
   fprintf('Mxmax=>Mxd -> ')
    X = sprintf('%f => %f',Mxmax,Mxd);%devuelve los valores como una cadena (sprinf)
      %a partir de %f convirte los valores de coma flotante en punto fijo
      disp(X)
       fprintf('\nMymax=>Myd -> ')
       Y= sprintf('%f => %f',Mymax,Myd); %devuelve los valores como una cadena (sprinf)
      %a partir de %f convirte los valores de coma flotante en punto fijo
      disp(Y)
      disp("Cumple con los requisitos dados")
      hold off;
%       figure('Name','Dimensionado seccin','NumberTitle','off');
      seccion(0.5,b/2+b/5,h/2+h/10);%esviada_comprobar_v4
    
end
 
 else %Mxd<Myd---------------------------------------------------------
    Asup=Asup+2;
    Adch=Adch+1;
        
armadura_sup()

%Impresin por pantalla de los datos---------------------------------------
%sobreescribo el area Ai del principio por el nuevo area Ai hallada

fprintf('Ai=[N redondos diametro1 Diametro1 Recubrimiento N redondos diametro2 Diametro2')
numero_redondos_diametro1_sup=2;numero_redondos_diametro1_inf=2;
numero_redondos_diametro2_dch=0;numero_redondos_diametro2_izq=0;

Ai=[[numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
    [numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
    [numero_redondos_diametro2_dch 0 r numero_redondos_diametro1_dch diametro_1_dch ]
    [numero_redondos_diametro2_dch 0 r numero_redondos_diametro1_dch diametro_1_dch ]
]

Matriz_optimizacion=Ai;

acero=armadura();
%seccion(0.5,b/2+b/5,h/2+h/10);

[Li,Wi]=integraHammer(); % integracion de Hammer
[n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
[nodos,eltos]=discretiza(); % discretizacion area bruta
options = optimoptions('fsolve','Display','off');
s0=[0 0 0];
s=fsolve(@(s)calcula(s),s0,options);

vv=esfuerzos(s);
Mxmax=vv(1);
Mymax=vv(2);
if(Mxmax>Mxd) & Mymax>Myd
   fprintf('Mxmax>Mxd -> ')
    X = sprintf('%f > %f',Mxmax,Mxd);%devuelve los valores como una cadena (sprinf)
      %a partir de %f convirte los valores de coma flotante en punto fijo
      disp(X)
      fprintf('\nMymax=>Myd -> ')
            Y= sprintf('%f > %f',Mymax,Myd); %devuelve los valores como una cadena (sprinf)
      %a partir de %f convirte los valores de coma flotante en punto fijo
      disp(Y)
      disp("Cumple con los requisitos dados")
      hold off;
%       figure('Name','Dimensionado seccin','NumberTitle','off');
      seccion(0.5,b/2+b/5,h/2+h/10);%esviada_comprobar_v4
end
 end 
end  

end

%-------------------------------------------------------------------------
function armado_simple_v3

    simple1()
    simple2()
    
    function simple1
%armo primeramente la parte superior e inferior while Mxmax<Myd, y una 
%vez que esta dimensionado esas partes, armo los laterales while Mymax<Myd
%-------------------------------------------------------------------------------

%------------------------------------------------------------------------

%Llamada a las funciones de las distintas armaduras
armadura_sup_s()
 
%Armadura superior - Armadura inferior-------------------------------------

function armadura_sup_s
%La armadura superior e inferior son iguales

%Parmetros--------------------
 
% Asup=500; %area armadura superior
%x(1)=diametro 1, x(2)=diametro 2, x(3)=n de redondos de diametro 2
%lb = [6 6 1]; %limites inferiores de x(1), x(2) y x(3)
%ub = [40 40 20]; %limites superiores de x(1), x(2) y x(3)

% Como cada conjunto de valores de los diametros tienen 10 miembros
%se debe discretizar en un rango de variables [1 10], por lo que
%los nuevos limites inferiores y superiores quedan de la siguiente forma
lb = [1 1 1]; %limites inferiores de x(1), x(2) y x(3)
ub = [10 10 20]; %limites superiores de x(1), x(2) y x(3)
%el limite superior de x(3) determina hasta el n max de redondos a poner

function x = valores_posibles(x)
%Esta funcin crea las variables de los diametrox x(1) y x(2) definiendo 
%sus posibles valores

% Posibles valores para el diametro 1 x(1) y diamatro 2 x(2)
diam1 = [6 8 10 12 14 16 20 25 32 40];
diam2 = [6 8 10 12 14 16 20 25 32 40];
%n_red=1:1:10; puedo crear una variable que determine hasta que n de
%redondos quiero poner

% Discretiza valores, es decir, cada variable elige su valor a partir del
% vector dado
x(1) = diam1(x(1));
x(2) = diam2(x(2));
%x(3)=n_red(x(3)); si actuar ka variable en relacion al n max deseado
end

function [c, ceq] = restricciones(x)
%Esta funcion calcula los constraints/restricciones del problema, 
%es decir, son ecuaciones adicionales del problema

smin = 20; %mnima separacin entre barras

%EJEMPLO RESTRICCIONES
%c(1)=2*x(1)-diametro_1_sup;  %diametro_sup_extremos>=2*diametro_lateral 
%c(1)=diametro_1_sup-2*x(1);  %2*x(1)>=diametro_sup_extremos
%--------------------------------------------------------------------

c(1)=1.2501*x(2)-x(1);
c(2)=smin-((b-2*r-2*(x(1))-(x(3))*(x(2)))/((x(3)+1))); %separacion entre barras > 20
c(3)=Asup-(2*(pi*((x(1)/2)^2))+(x(3)*(pi*((x(2)/2)^2))));%el area a obtener debe ser mayor que el 
%area (A) obtenido por los esfuerzos



ceq = []; %matriz ceq
end

function a = area(x)
%Funcin que determina el valor del area a partir de las 3 variables

a=(2*(pi*(x(1)^2)/4))+(x(3)*(pi*(x(2)^2)/4)); %area a obtener
end


function a = variables_discretiza(x)

x = valores_posibles(x);% Map de variables discretas

a = area(x); % Area a partir de las variables
end

function [c, ceq] = restricciones_discretiza(x)
%funcion de la matriz de las restricciones

x = valores_posibles(x); % Map variables discretas

[c, ceq] = restricciones(x); %evaluacin de las restricciones
end

%[xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,n de variables, [], [], [], [], lb, ub, @restricciones_discretiza, n de variables que no poseen parametros a elegir, opts);
[xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,3, [], [], [], [], lb, ub, @restricciones_discretiza, 1:3);
% area_obtenida_sup=fbestDisc;
xbestDisc = valores_posibles(xbestDisc);%hago la llamda para obtener los diametros
%dentro de los posible valores especificados
diametro_1_sup=xbestDisc(1);
diametro_2_sup=xbestDisc(2);
numero_redondos_diametro2_sup=xbestDisc(3);
% area_obtenida_sup_int=numero_redondos_diametro2_sup*pi*(diametro_2_sup/2)^2;
separacion_barras_sup=(b-2*r-2*(diametro_1_sup)-(numero_redondos_diametro2_sup)*(diametro_2_sup))/((numero_redondos_diametro2_sup+1));
%display(xbestDisc);

end


% %Impresin por pantalla de los datos---------------------------------------
% %sobreescribo el area Ai del principio por el nuevo area Ai hallada
% 
 fprintf('Ai=[N redondos diametro1 Diametro1 Recubrimiento N redondos diametro2 Diametro2')
 numero_redondos_diametro1_sup=2;numero_redondos_diametro1_inf=2;
 numero_redondos_diametro2_dch=0;numero_redondos_diametro2_izq=0;
% % Malla=[[diametro_1_sup numero_redondos_diametro1_sup diametro_2_sup numero_redondos_diametro2_sup r]
%     [diametro_1_sup numero_redondos_diametro1_sup diametro_2_sup numero_redondos_diametro2_sup r]
%     [0 numero_redondos_diametro2_dch diametro_1_dch numero_redondos_diametro1_dch r]
%     [0 numero_redondos_diametro2_dch diametro_1_dch numero_redondos_diametro1_dch r]
% ]
Ai=[[numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
    [numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
    [0 0 0 0 0]
    [0 0 0 0 0]
]

Matriz_simple=Ai;



%------------------------------------------------------------------------

acero=armadura();
%seccion(0.5,b/2+b/5,h/2+h/10);

[Li,Wi]=integraHammer(); % integracion de Hammer
[n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
[nodos,eltos]=discretiza(); % discretizacion area bruta


emax=ecu2;

options = optimoptions('fsolve','Display','off');
s0=[0 0 0];
s=fsolve(@(s)calcula(s),s0,options);

vv=esfuerzos(s);
Mxmax=vv(1)
Mxmax1=0;
Mymax=vv(2)
Mymax1=0;

    function [Li,Wi]=integraHammer()
        % metode de integracion de Hammer eltos triangulares
        
        Li=1/2*[
            [1 1 0]
            [1 0 1]
            [0 1 1]
            ]; % coordenadas
        Wi=1/6*[1 1 1]; % pesos        
        
    end        

    function [n,ec2,ecu2]=initHormigon(fck)
        % diagrama parabola-rectangulo
        
        if(fck<50)
            n=2;
            ec2=2/1000;
            ecu2=3.5/1000;
        else
            n=1.4+23.4*((90-fck)/100)^4;
            ec2=(2.0+0.085*(fck-50)^0.53)/1000;
            ecu2=(2.6+35*((90-fck)/100)^4)/1000;            
        end
        
    end

    function [nodos,eltos]=discretiza()
        % discretizacion
        x01=-b/2:b/10:b/2;
        y01=-h/2:h/10:h/2;

        [X,Y] = meshgrid(x01,y01);

        nx=size(x01);
        nx=nx(2);
        x=reshape(X,nx^2,1);

        ny=size(y01);
        ny=ny(2);
        y=reshape(Y,ny^2,1);
        DT=delaunayTriangulation(x,y); % triangulacion de Delaunay
%         figure;
%         triplot(DT)

        nodos=DT.Points; % nodos
        eltos=DT.ConnectivityList; % elementos
                
    end

    function v=defLong(x,y,s)        
        % plano de deformacion
        % (x,y): coordenadas en la seccion
        % e0: deformacion axial
        % ax: giro en torno al eje x
        % ay: giro en torno al eje y
        
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=e0+ay*x+ax*y;        
    end

    function v=tensionHormigon(x,y,s)
        % tension en el Hormigon
        v=0;
        
        ec=defLong(x,y,s);
        if((ec>0)&&(ec<=ec2))
            v=fcd*(1-(1-ec/ec2)^n);            
        elseif(ec>ec2)
            v=fcd;            
        end
                    
    end

    function v=tensionAcero(x,y,s)
        % tension en el Acero
        v=0;
        
        ec=defLong(x,y,s);
        if(ec<-fyd/Es)
            v=-fyd;
        elseif(-fyd/Es<ec)&&(ec<fyd/Es)
            v=Es*ec;
        else
            v=fyd;
        end
                    
    end

    function v0=calcula(s)
        % calcula e0 para Nd
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=zeros(1,3);
        x=0;
        y=0;
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            vJ=calculaJ(nk);
            v0=intHammer(nk,s);
            v=v+v0*vJ;
        end        
        
        % aportacion del acero
        n0=size(acero);
        n0=n0(1); % numero de armaduras, me dice el n de redondos que tengo,
        %da igual que columna coger, porque al final cada fila posee sus
        %datos, y el n final de redondos es el n de filas
        for k=1:n0
            x=acero(k,1); %determina la posicin x de cada redondo (k=fila, 1=columna)
            y=acero(k,2); %determina la posicin y de cada redondo
            d=acero(k,3); %determina el diametro de cada redondo
            A=pi*(d/2)^2; % area que implica cada redondo
            ts=tensionAcero(x,y,s); %la tensin del acero viene dada por una funcin
            %que determina su tensin dependiendo de su deformacin
            v=v+A*ts*[1 y x]; %vector que determina los esfuerzos
        end %end del bucle for
        
        v(1)=v(1)/1000; % axil (kN)
        v(2)=v(2)/10^6;% flector Mx (kNm)
        v(3)=v(3)/10^6; % flector My (kNm)
        
        v0=zeros(1,2);
        v0(1)=v(1)-Nd;
        
        v1=ecmax(s);                 
        v0(2)=v1-emax;
        
        v0(3)=v(3)-Myd;
        
    end %end de la funcion calcula(s)

    function v0=esfuerzos(s)
        % (Nc,Mc): esfuerzos en el hormign
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=zeros(1,3);
        x=0;
        y=0;
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            vJ=calculaJ(nk);
            v0=intHammer(nk,s);
            v=v+v0*vJ;
        end 
        
        % aportacion del acero
        n0=size(acero);
        n0=n0(1); % numero de armaduras
        for k=1:n0
            x=acero(k,1);
            y=acero(k,2);
            d=acero(k,3);
            A=pi*(d/2)^2; % area
            ts=tensionAcero(x,y,s);
            v=v+A*ts*[1 y x];
        end
        
        v(1)=v(1)/1000; % axil (kN)
        v(2)=v(2)/10^6; % flector Mx (kNm)
        v(3)=v(3)/10^6; % flector My (kNm)
        
        v0=[v(2) v(3)];
        
    end %end de la funcion esfuerzos(s)

    function v0=ecmax(s)
        % deformacion maxima en el hormigon
         
        v0=0;       
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            for j=1:3
                x=nk(j,1);
                y=nk(j,2);
                v0=max(v0,defLong(x,y,s));
            end
        end                
    end

    function vJ=calculaJ(nk)
        % calcula el jacobiano
        % vk: elemento k
        % nk: nodos del elemento k
        vJ=zeros(2);
        vJ(1,1)=[1 0 -1]*nk(:,1);
        vJ(1,2)=[1 0 -1]*nk(:,2);
        
        vJ(2,1)=[0 1 -1]*nk(:,1);
        vJ(2,2)=[0 1 -1]*nk(:,2);
        
        vJ=det(vJ);              
                       
    end

    function v=intHammer(nk,s)
        % coordenadas (x,y) a partir de (L1,L2,L3)
        
        v=zeros(1,3);    
        for i=1:3
                Lj=Li(i,:);
                x=Lj*nk(:,1);
                y=Lj*nk(:,2);
                v=v+Wi(i)*tensionHormigon(x,y,s)*[1 y x];
        end                
    end      

%-----------------------------------
    function v=armadura()
       
next=sum(Ai(:,1)); %calcula la suma de los redondos en los extremos
ncen=sum(Ai(:,4)); %calcula la suma de los redondos intermedios
na=next+ncen; %suma total de todos los redondos
v=zeros(na,3); %matriz de ceros de 3 columnas y na filas, 
%siendo la matriz v=[pos.x pos.y diametro]

%---------------------------
i=1; %armadura superior
ni=Ai(i,1); %n redondos en la armadura superior en los extremos
nc=Ai(i,4); %n redondos intermedios en la armadura superior
nt=ni+nc;
di=Ai(i,2); %diametro de los redondos en los extremos
dc=Ai(i,5); %diametro de los redondos intermedios
ri=Ai(i,3); %recubrimiento
da=(b-2*r-2*(di)-(nc)*(dc))/((nc+1));
k=1;l=0;
v(k,:)=[(b/2)-ri-(di/2) (h/2)-ri-(di/2) di];
v(ni+nc,:)=[v(k,1)-(b-2*r-di) h/2-ri-(di/2) di];
% for j=2:ni+nc-1
%      v(k+j-1,:)=[v(k+j-2,1)-((di/2)+(dc/2)+da) h/2-ri dc] 
%      l=l+1;
% end

if nt==3
    v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) h/2-ri-(di/2) dc];
    %v(ni+nc,:)=[v(k,1)-(b-2*r-di) h/2-ri di];
else if nt>3
    v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) h/2-ri-(di/2) dc];
    for j=3:ni+nc-1 
    v(k+j-1,:)=[v(k+j-2,1)-(dc+da) h/2-ri-(di/2) dc]; %si tengo ms de 1 redondo intermedio
%la ecuacin del posicionamiento vara
l=l+1
    end
    end
end
k=nt+1;
%---------------------------

i=2; % armadura inferior

ni=Ai(i,1); %n redondos en la armadura inferior en los extremos
nc=Ai(i,4); %n redondos intermedios en la armadura inferior
nt=ni+nc;
di=Ai(i,2); %diametro de los redondos en los extremos
dc=Ai(i,5); %diametro de los redondos intermedios
ri=Ai(i,3); %recubrimiento
da=(b-2*r-2*(di)-(nc)*(dc))/((nc+1));
k=nt+1;l=0;
v(k,:)=[(b/2)-ri-(di/2) (-h/2)+ri+(di/2) di];
v(nt+ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri+(di/2) di];
% for j=2:ni+nc-1
%      v(k+j-1,:)=[v(k+j-2,1)-((di/2)+(dc/2)+da) h/2-ri dc] 
%      l=l+1;
% end

if nt==3
    v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) -h/2+ri+(di/2) dc];
   % v(ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];
else if nt>3
    v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) -h/2+ri+(di/2) dc];
    for j=3:ni+nc-1 
    v(k+j-1,:)=[v(k+j-2,1)-(dc+da) -h/2+ri+(di/2) dc]; %si tengo ms de 1 redondo intermedio
%la ecuacin del posicionamiento vara
l=l+1
    end
    end
end
k=nt+1;

%---------------------------

i=3; % armadura derecha

ni=Ai(i,4); %n redondos en la armadura derecha
nsup=Ai(1,1); %n redondos extremos superiores
nl=ni+nsup; %nde redondos lateral
di=Ai(i,5); %diametro de los redondos en lateral
dspex=Ai(1,2); %diametro redondos extremos superiores
dscn=Ai(1,5); %diametro redondos intermedios superiores
ri=Ai(i,3); %recubrimiento
da= (h-2*r-(2*dspex)-(ni)*(di))/((ni+1));
k=nt+nt+1;l=0;
v(k,:)=[(b/2)-ri-(dspex/2) (h/2)-(ri+dspex+da+(di/2)) di]; %(b/2)-ri-(di/2)
%v(nt+ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];

if nl==3
   v(k,:)=[(b/2)-ri-(dspex/2) (h/2)-(ri+dspex+da+(di/2)) di];
   % v(ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];
else if nl>3
    v(k,:)=[(b/2)-ri-(dspex/2) (h/2)-(ri+dspex+da+(di/2)) di];
    for j=2:nl-2 %nl-2 porque tengo 2 redondos en los extremos 
    v(k+j-1,:)=[(b/2)-ri-(dspex/2) v(k+j-2,2)-(di+da) di]; %si tengo ms de 1 redondo intermedio
%la ecuacin del posicionamiento vara
l=l+1;
    end
    end
end
k=nt+nt+1;


%---------------------------

i=4; % armadura izquierda

ni=Ai(i,4); %n redondos en la armadura izquierda
nsup=Ai(1,1); %n redondos extremos superiores
nl=ni+nsup; %nde redondos lateral
di=Ai(i,5); %diametro de los redondos en lateral
dspex=Ai(1,2); %diametro redondos extremos superiores
dscn=Ai(1,5); %diametro redondos intermetios superiores
ri=Ai(i,3); %recubrimiento
da= (h-2*r-(2*dspex)-(ni)*(di))/((ni+1));
k=nt+nt+ni+1;l=0;
v(k,:)=[(-b/2)+ri+(di/2) (h/2)-(ri+dspex+da+(di/2)) di];
%v(nt+ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];

if nl==3
   v(k,:)=[(-b/2)+ri+(dspex/2) (h/2)-(ri+dspex+da+(di/2)) di];
   % v(ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];
else if nl>3
    v(k,:)=[(-b/2)+ri+(dspex/2) (h/2)-(ri+dspex+da+(di/2)) di];
    for j=2:nl-2 %nl-2 porque tengo 2 redondos en los extremos 
    v(k+j-1,:)=[(-b/2)+ri+(dspex/2) v(k+j-2,2)-(di+da) di]; %si tengo ms de 1 redondo intermedio
%la ecuacin del posicionamiento vara
l=l+1;
    end
    end
end
k=nt+nt+ni+1;
    end

%--------------------------------

    function seccion(esc,x01,y01) %creo una seccin a escala 1:2
        % dibuja seccion
        H1=[[b/2 h/2]
            [-b/2 h/2]
            [-b/2 -h/2]
            [b/2 -h/2]
            ];
        H1(:,1)=H1(:,1)+x01;
        H1(:,2)=H1(:,2)+y01;
        H1=esc*H1;

         line(H1(1:2,1),H1(1:2,2),'LineWidth',2);
         line(H1(2:3,1),H1(2:3,2),'LineWidth',2);
         line(H1(3:4,1),H1(3:4,2),'LineWidth',2);
         x=zeros(1,2);y=zeros(1,2);        
         x(1)=H1(1,1);x(2)=H1(4,1);
         y(1)=H1(1,2);y(2)=H1(4,2);
         line(x,y,'LineWidth',2);
        
        
        n0=size(acero); %tamao de la matriz acero
        n0=n0(1); %n de redondos que hay en la seccion
        for i=1:n0
            a=acero(i,:); %cojo cada fila de la matriz v de la funcin acero=armadura
            di=a(3)/2; %el diametro es la columna 3 del vector a
            t=0:pi/30:2*pi; %creo los parametros de los crculos
            x=a(1)+di*cos(t); %x=posicin 1 (centro del redondo) del vector a en x + diametro*cos(t)
            y=a(2)+di*sin(t);
            x=x+x01;y=y+y01;
            x=esc*x;y=esc*y;
            hold on;
            subplot(1,2,1);%dibujo en la parte derecha
            plot(x,y,'r','LineWidth',1.5);
            title('Armado simple')
            axis equal; %Utilice la misma longitud para las unidades de datos a lo largo de cada eje
        end 
                   line(H1(1:2,1),H1(1:2,2),'LineWidth',2);
         line(H1(2:3,1),H1(2:3,2),'LineWidth',2);
         line(H1(3:4,1),H1(3:4,2),'LineWidth',2);
         x=zeros(1,2);y=zeros(1,2);        
         x(1)=H1(1,1);x(2)=H1(4,1);
         y(1)=H1(1,2);y(2)=H1(4,2);
         line(x,y,'LineWidth',2);

    end
%--------------------------------

% for inicio=1:10;
 while Mxmax<=Mxd %| Mymax<=Myd
%    for inicio=1:30;
    hold off;
    %clc;
     if Mxd>Myd
    Asup=Asup+5;
%     Adch=Adch+2
%     Asup=Asup+2;
%     Adch=Adch+2;
        
armadura_sup_s()

%Impresin por pantalla de los datos---------------------------------------
%sobreescribo el area Ai del principio por el nuevo area Ai hallada

fprintf('Ai=[N redondos diametro1 Diametro1 Recubrimiento N redondos diametro2 Diametro2')
numero_redondos_diametro1_sup=2;numero_redondos_diametro1_inf=2;
numero_redondos_diametro2_dch=0;numero_redondos_diametro2_izq=0;
numero_redondos_diametro1_dch=0;diametro_1_dch=0;

Ai=[[numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
    [numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
    [0 0 0 0 0 ]
    [0 0 0 0 0 ]
]

Matriz_simple=Ai;



acero=armadura();
%seccion(0.5,b/2+b/5,h/2+h/10);

[Li,Wi]=integraHammer(); % integracion de Hammer
[n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
[nodos,eltos]=discretiza(); % discretizacion area bruta
options = optimoptions('fsolve','Display','off');
s0=[0 0 0];
s=fsolve(@(s)calcula(s),s0,options);

vv=esfuerzos(s);
Mxmax=vv(1)
% Mxmax1=Mxmax;
Mymax=vv(2)

     end
 end

if(Mxmax>Mxd)
    Ai1=[[numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
    [numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup]
  ];
Matriz_simple1=Ai1
       hold on;
       clf; 
       figure('Name','Armado Simple','NumberTitle','off');
       seccion(0.5,b/2+b/5,h/2+h/10);
        subplot(1,2,2);
  text(0,3,'Nred');
  text(0.9,3,'Diam');
  text(1.8,3,'r');
  text(2.10,3,'N red');
  text(3,3,'Diam');
  top=text(2,2.25,num2str(Matriz_simple1),'HorizontalAlignment','center');
  sop = top.FontSize;
  top.FontSize = 16;
  line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4]);
  axis off tight
% clc  

% end
Matriz_simple=Ai;
area_simple1=2*((Ai(1,1)*pi*((Ai(1,2)/2)^2))+(Ai(1,4)*pi*((Ai(1,5)/2)^2)))+2*((Ai(3,4)*pi*((Ai(3,5)/2)^2)));
end
    end


%------------------------------------------------------------------------

    function simple2 
       
 armadura_dch()

%Armadura derecha - Armadura izquierda--------------------------------------

  function armadura_dch
% % %La armadura derecha e izquierda son iguales
% %     
% % %Adch=200; %area armadura derecha
% % 
  lb = [1 1]; %limites inferiores de x(1)=diametro1, x(2)=n redondos de diametro1
  ub = [10 20]; %limites superiores de x(1), x(2) 
% % 
  function x = valores_posibles(x)
%  
  diam1 = [6 8 10 12 14 16 20 25 32 40];
  %diam2 = [6 8 10 12 14 16 20 25 32 40];
%  
  x(1) = diam1(x(1));
  %x(2) = diam2(x(2));
% % 
  end
%  
  function [c, ceq] = restricciones(x)
%  
  smin = 20; %mnima separacin entre barras
%  
% % %EJEMPLO RESTRICCIONES
% % %c(1)=2*x(1)-diametro_1_sup;  %diametro_sup_extremos>=2*diametro_lateral 
% % %c(1)=diametro_1_sup-2*x(1);  %2*x(1)>=diametro_sup_extremos
% % %--------------------------------------------------------------------
% % 
  c(1)=smin-((h-2*r-(40)-(x(2))*(x(1)))/((x(2)+1))); %separacion entre barras > 20
  c(2)=Adch-(x(2)*(pi*(x(1)^2)/4));%el area a obtener debe ser mayor que el 
% % %area (A) obtenido por los esfuerzos
% % 
  ceq = []; %matriz ceq
  end
% % 
  function a = area(x)
%  %Funcin que determina el valor del area a partir de las 3 variables
% % 
  a=(x(2)*(pi*(x(1)^2)/4)); %area a obtener
  end
% % 
% % 
  function a = variables_discretiza(x)
% % 
  x = valores_posibles(x);% Map de variables discretas
% % 
  a = area(x); % Area a partir de las variables
  end
% % 
  function [c, ceq] = restricciones_discretiza(x)
%  %funcion de la matriz de las restricciones
% % 
  x = valores_posibles(x); % Map variables discretas
% % 
  [c, ceq] = restricciones(x); %evaluacin de las restricciones
  end
% % 
% % [xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,n de variables, [], [], [], [], lb, ub, @restricciones_discretiza, n de variables que no poseen parametros a elegir, opts);
[xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,2, [], [], [], [], lb, ub, @restricciones_discretiza, 1:2);
  area_obtenida_dch=fbestDisc;
  xbestDisc = valores_posibles(xbestDisc);%hago la llamda para obtener los diametros
% % %dentro de los posible valores especificados
  diametro_1_dch=xbestDisc(1);
%   diametro_2_dch=xbestDisc(2);
 numero_redondos_diametro1_dch=xbestDisc(2);
  separacion_barras_dch=(h-2*r-(80)-(numero_redondos_diametro1_dch)*(diametro_1_dch))/((numero_redondos_diametro1_dch+1));
  display(xbestDisc);
% % 
  end
% 
Ai2=[ [0 0 0 0 0]
    [0 0 0 0 0]
    [0 0 r numero_redondos_diametro1_dch diametro_1_dch]
    [0 0 r numero_redondos_diametro1_dch diametro_1_dch]
]

Matriz_simple2=Ai2;



%------------------------------------------------------------------------

acero=armadura();
%seccion(0.5,b/2+b/5,h/2+h/10);

[Li,Wi]=integraHammer(); % integracion de Hammer
[n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
[nodos,eltos]=discretiza(); % discretizacion area bruta


emax=ecu2;

options = optimoptions('fsolve','Display','off');
s0=[0 0 0];
s=fsolve(@(s)calcula(s),s0,options);

vv=esfuerzos(s);
Mxmax=vv(1)
Mxmax1=0;
Mymax=vv(2)
Mymax1=0;

    function [Li,Wi]=integraHammer()
        % metode de integracion de Hammer eltos triangulares
        
        Li=1/2*[
            [1 1 0]
            [1 0 1]
            [0 1 1]
            ]; % coordenadas
        Wi=1/6*[1 1 1]; % pesos        
        
    end        

    function [n,ec2,ecu2]=initHormigon(fck)
        % diagrama parabola-rectangulo
        
        if(fck<50)
            n=2;
            ec2=2/1000;
            ecu2=3.5/1000;
        else
            n=1.4+23.4*((90-fck)/100)^4;
            ec2=(2.0+0.085*(fck-50)^0.53)/1000;
            ecu2=(2.6+35*((90-fck)/100)^4)/1000;            
        end
        
    end

    function [nodos,eltos]=discretiza()
        % discretizacion
        x01=-b/2:b/10:b/2;
        y01=-h/2:h/10:h/2;

        [X,Y] = meshgrid(x01,y01);

        nx=size(x01);
        nx=nx(2);
        x=reshape(X,nx^2,1);

        ny=size(y01);
        ny=ny(2);
        y=reshape(Y,ny^2,1);
        DT=delaunayTriangulation(x,y); % triangulacion de Delaunay
%         figure;
%         triplot(DT)

        nodos=DT.Points; % nodos
        eltos=DT.ConnectivityList; % elementos
                
    end

    function v=defLong(x,y,s)        
        % plano de deformacion
        % (x,y): coordenadas en la seccion
        % e0: deformacion axial
        % ax: giro en torno al eje x
        % ay: giro en torno al eje y
        
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=e0+ay*x+ax*y;        
    end

    function v=tensionHormigon(x,y,s)
        % tension en el Hormigon
        v=0;
        
        ec=defLong(x,y,s);
        if((ec>0)&&(ec<=ec2))
            v=fcd*(1-(1-ec/ec2)^n);            
        elseif(ec>ec2)
            v=fcd;            
        end
                    
    end

    function v=tensionAcero(x,y,s)
        % tension en el Acero
        v=0;
        
        ec=defLong(x,y,s);
        if(ec<-fyd/Es)
            v=-fyd;
        elseif(-fyd/Es<ec)&&(ec<fyd/Es)
            v=Es*ec;
        else
            v=fyd;
        end
                    
    end

    function v0=calcula(s)
        % calcula e0 para Nd
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=zeros(1,3);
        x=0;
        y=0;
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            vJ=calculaJ(nk);
            v0=intHammer(nk,s);
            v=v+v0*vJ;
        end        
        
        % aportacion del acero
        n0=size(acero);
        n0=n0(1); % numero de armaduras, me dice el n de redondos que tengo,
        %da igual que columna coger, porque al final cada fila posee sus
        %datos, y el n final de redondos es el n de filas
        for k=1:n0
            x=acero(k,1); %determina la posicin x de cada redondo (k=fila, 1=columna)
            y=acero(k,2);%determina la posicin y de cada redondo
            d=acero(k,3); %determina el diametro de cada redondo
            centro=[x y];
           
            A=pi*(d/2)^2; % area que implica cada redondo
            ts=tensionAcero(x,y,s); %la tensin del acero viene dada por una funcin
            %que determina su tensin dependiendo de su deformacin
            v=v+A*ts*[1 y x]; %vector que determina los esfuerzos
        end %end del bucle for
        
        v(1)=v(1)/1000; % axil (kN)
        v(2)=v(2)/10^6;% flector Mx (kNm)
        v(3)=v(3)/10^6; % flector My (kNm)
        
        v0=zeros(1,2);
        v0(1)=v(1)-Nd;
        
        v1=ecmax(s);                 
        v0(2)=v1-emax;
        
        v0(3)=v(3)-Myd;
        
    end %end de la funcion calcula(s)

    function v0=esfuerzos(s)
        % (Nc,Mc): esfuerzos en el hormign
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=zeros(1,3);
        x=0;
        y=0;
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            vJ=calculaJ(nk);
            v0=intHammer(nk,s);
            v=v+v0*vJ;
        end 
        
        % aportacion del acero
        n0=size(acero);
        n0=n0(1); % numero de armaduras
        for k=1:n0
            x=acero(k,1);
            y=acero(k,2);
            d=acero(k,3);
            A=pi*(d/2)^2; % area
            ts=tensionAcero(x,y,s);
            v=v+A*ts*[1 y x];
        end
        
        v(1)=v(1)/1000; % axil (kN)
        v(2)=v(2)/10^6; % flector Mx (kNm)
        v(3)=v(3)/10^6; % flector My (kNm)
        
        v0=[v(2) v(3)];
        
    end %end de la funcion esfuerzos(s)

    function v0=ecmax(s)
        % deformacion maxima en el hormigon
         
        v0=0;       
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            for j=1:3
                x=nk(j,1);
                y=nk(j,2);
                v0=max(v0,defLong(x,y,s));
            end
        end                
    end

    function vJ=calculaJ(nk)
        % calcula el jacobiano
        % vk: elemento k
        % nk: nodos del elemento k
        vJ=zeros(2);
        vJ(1,1)=[1 0 -1]*nk(:,1);
        vJ(1,2)=[1 0 -1]*nk(:,2);
        
        vJ(2,1)=[0 1 -1]*nk(:,1);
        vJ(2,2)=[0 1 -1]*nk(:,2);
        
        vJ=det(vJ);              
                       
    end

    function v=intHammer(nk,s)
        % coordenadas (x,y) a partir de (L1,L2,L3)
        
        v=zeros(1,3);    
        for i=1:3
                Lj=Li(i,:);
                x=Lj*nk(:,1);
                y=Lj*nk(:,2);
                v=v+Wi(i)*tensionHormigon(x,y,s)*[1 y x];
        end                
    end      

%-----------------------------------
  function v=armadura()
       
next=sum(Ai2(:,1)); %calcula la suma de los redondos en los extremos
ncen=sum(Ai2(:,4)); %calcula la suma de los redondos intermedios
na=next+ncen; %suma total de todos los redondos
v=zeros(na,3); %matriz de ceros de 3 columnas y na filas, 
%siendo la matriz v=[pos.x pos.y diametro]

%---------------------------
i=1; %armadura superior
ni=Ai2(i,1); %n redondos en la armadura superior en los extremos
nc=Ai2(i,4);%n redondos intermedios en la armadura superior
nt=ni+nc;
di=Ai2(i,2); %diametro de los redondos en los extremos
dc=Ai2(i,5); %diametro de los redondos intermedios
ri=Ai2(i,3); %recubrimiento
da=(b-2*r-2*(di)-(nc)*(dc))/((nc+1));
k=1;l=0;
% v(k,:)=[(b/2)-ri-(di/2) (h/2)-ri-(di/2) di];
% v(ni+nc,:)=[v(k,1)-(b-2*r-di) h/2-ri-(di/2) di];
% for j=2:ni+nc-1
%      v(k+j-1,:)=[v(k+j-2,1)-((di/2)+(dc/2)+da) h/2-ri dc] 
%      l=l+1;
% end

% if nt==3
%     v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) h/2-ri-(di/2) dc];
%     %v(ni+nc,:)=[v(k,1)-(b-2*r-di) h/2-ri di];
% else if nt>3
%     v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) h/2-ri-(di/2) dc];
%     for j=3:ni+nc-1 
%     v(k+j-1,:)=[v(k+j-2,1)-(dc+da) h/2-ri-(di/2) dc]; %si tengo ms de 1 redondo intermedio
% %la ecuacin del posicionamiento vara
% l=l+1
%     end
%     end
% end
k=nt+1;
%---------------------------

i=2; % armadura inferior

ni=Ai2(i,1); %n redondos en la armadura inferior en los extremos
nc=Ai2(i,4); %n redondos intermedios en la armadura inferior
nt=ni+nc;
di=Ai2(i,2); %diametro de los redondos en los extremos
dc=Ai2(i,5); %diametro de los redondos intermedios
ri=Ai2(i,3); %recubrimiento
da=(b-2*r-2*(di)-(nc)*(dc))/((nc+1));
k=nt+1;l=0;
% v(k,:)=[(b/2)-ri-(di/2) (-h/2)+ri+(di/2) di];
% v(nt+ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri+(di/2) di];
% for j=2:ni+nc-1
%      v(k+j-1,:)=[v(k+j-2,1)-((di/2)+(dc/2)+da) h/2-ri dc] 
%      l=l+1;
% end

% if nt==3
%     v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) -h/2+ri+(di/2) dc];
%    % v(ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];
% else if nt>3
%     v(k+1,:)=[v(k,1)-((di/2)+(dc/2)+da) -h/2+ri+(di/2) dc];
%     for j=3:ni+nc-1 
%     v(k+j-1,:)=[v(k+j-2,1)-(dc+da) -h/2+ri+(di/2) dc]; %si tengo ms de 1 redondo intermedio
% %la ecuacin del posicionamiento vara
% l=l+1
%     end
%     end
% end
k=nt+1;

%---------------------------

i=3; % armadura derecha

ni=Ai2(i,4) %n redondos en la armadura derecha
nsup=Ai2(1,1); %n redondos extremos superiores
nl=ni+nsup; %nde redondos lateral
di=Ai2(i,5); %diametro de los redondos en lateral
dspex=60; %diametro redondos extremos superiores
dspex2=40;
dscn=Ai2(1,5); %diametro redondos intermedios superiores
ri=Ai2(i,3); %recubrimiento
da= (h-2*r-(2*dspex)-(ni)*(di))/((ni+1));
k=nt+nt+1;l=0;
v(k,:)=[(b/2)-ri-(dspex2/2) (h/2)-(ri+dspex+da+(di/2)) di]; %(b/2)-ri-(di/2)
%v(nt+ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];

if nl==3
   v(k,:)=[(b/2)-ri-(dspex2/2) (h/2)-(ri+dspex+da+(di/2)) di];
   % v(ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];
else if nl>3
    v(k,:)=[(b/2)-ri-(dspex2/2) (h/2)-(ri+dspex+da+(di/2)) di];
    for j=2:nl-2 %nl-2 porque tengo 2 redondos en los extremos 
    v(k+j-1,:)=[(b/2)-ri-(dspex2/2) v(k+j-2,2)-(di+da) di]; %si tengo ms de 1 redondo intermedio
%la ecuacin del posicionamiento vara
l=l+1;
    end
    end
end
k=nt+nt+1;


%---------------------------

i=4; % armadura izquierda

ni=Ai2(i,4); %n redondos en la armadura izquierda
nsup=Ai2(1,1); %n redondos extremos superiores
nl=ni+nsup; %nde redondos lateral
di=Ai2(i,5); %diametro de los redondos en lateral
dspex=60; %diametro redondos extremos superiores
dspex2=40;
dscn=Ai2(1,5); %diametro redondos intermetios superiores
ri=Ai2(i,3); %recubrimiento
da= (h-2*r-(2*dspex)-(ni)*(di))/((ni+1));
k=nt+nt+ni+1;l=0;
v(k,:)=[(-b/2)+ri+(di/2) (h/2)-(ri+dspex+da+(di/2)) di];
%v(nt+ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];

if nl==3
   v(k,:)=[(-b/2)+ri+(dspex2/2) (h/2)-(ri+dspex+da+(di/2)) di];
   % v(ni+nc,:)=[v(k,1)-(b-2*r-di) -h/2+ri di];
else if nl>3
    v(k,:)=[(-b/2)+ri+(dspex2/2) (h/2)-(ri+dspex+da+(di/2)) di];
    for j=2:nl-2 %nl-2 porque tengo 2 redondos en los extremos 
    v(k+j-1,:)=[(-b/2)+ri+(dspex2/2) v(k+j-2,2)-(di+da) di]; %si tengo ms de 1 redondo intermedio
%la ecuacin del posicionamiento vara
l=l+1;
    end
    end
end
k=nt+nt+ni+1;
    end


%--------------------------------

    function seccion(esc,x01,y01) %creo una seccin a escala 1:2
        % dibuja seccion
        H1=[[b/2 h/2]
            [-b/2 h/2]
            [-b/2 -h/2]
            [b/2 -h/2]
            ];
        H1(:,1)=H1(:,1)+x01;
        H1(:,2)=H1(:,2)+y01;
        H1=esc*H1;

         line(H1(1:2,1),H1(1:2,2),'LineWidth',2);
         line(H1(2:3,1),H1(2:3,2),'LineWidth',2);
         line(H1(3:4,1),H1(3:4,2),'LineWidth',2);
         x=zeros(1,2);y=zeros(1,2);        
         x(1)=H1(1,1);x(2)=H1(4,1);
         y(1)=H1(1,2);y(2)=H1(4,2);
         line(x,y,'LineWidth',2);
        
        
        n0=size(acero); %tamao de la matriz acero
        n0=n0(1); %n de redondos que hay en la seccion
        for i=1:n0
            a=acero(i,:); %cojo cada fila de la matriz v de la funcin acero=armadura
            di=a(3)/2; %el diametro es la columna 3 del vector a
            t=0:pi/30:2*pi; %creo los parametros de los crculos
            x=a(1)+di*cos(t); %x=posicin 1 (centro del redondo) del vector a en x + diametro*cos(t)
            y=a(2)+di*sin(t);
             x=x+x01;y=y+y01;
            x=esc*x;y=esc*y;
            
            hold on;
            subplot(1,2,1);%dibujo en la parte izq
%              centro=[x y]
%              viscircles(centro, di/2)
            plot(x,y,'r','LineWidth',1.5);
            title('Armado simple')
            axis equal; %Utilice la misma longitud para las unidades de datos a lo largo de cada eje
        end 
%                    line(H1(1:2,1),H1(1:2,2),'LineWidth',2);
%          line(H1(2:3,1),H1(2:3,2),'LineWidth',2);
%          line(H1(3:4,1),H1(3:4,2),'LineWidth',2);
%          x=zeros(1,2);y=zeros(1,2);        
%          x(1)=H1(1,1);x(2)=H1(4,1);
%          y(1)=H1(1,2);y(2)=H1(4,2);
%          line(x,y,'LineWidth',2);

    end
%--------------------------------


while Mymax<Myd

%     while (numero_redondos_diametro1_dch*(pi*((diametro_1_dch/2)^2)))<=Adch
   % keep r Matriz_simple fck fyk fcd fyd Es pregunta Ai numero_redondos_diametro1_sup diametro_1_sup numero_redondos_diametro2_sup diametro_2_sup   
   Ai2=[[0 0  0 0 0];
      [0 0 0 0 0];
      [0 0 r numero_redondos_diametro1_dch diametro_1_dch ];
      [0 0 r numero_redondos_diametro1_dch diametro_1_dch ];
  ]
Matriz_simple2=Ai2;
   armadura_dch()
     

     Adch=Adch+2;
    acero=armadura();
  %seccion(0.5,b/2+b/5,h/2+h/10);
  
  [Li,Wi]=integraHammer(); % integracion de Hammer
  [n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
  [nodos,eltos]=discretiza(); % discretizacion area bruta
  options = optimoptions('fsolve','Display','off');
  s0=[0 0 0];
  s=fsolve(@(s)calcula(s),s0,options);
%  
  vv=esfuerzos(s);
  Mxmax=vv(1);
  Mymax=vv(2);
%   centro=[x y]
%   viscircles(centro, di/2)
  Ai2=[[0 0  0 0 0];
      [0 0 0 0 0];
      [0 0 r numero_redondos_diametro1_dch diametro_1_dch ];
      [0 0 r numero_redondos_diametro1_dch diametro_1_dch ];
  ]
%        seccion(0.5,b/2+b/5,h/2+h/10);
%         subplot(1,2,1);
end

%     if Mymax>(Myd+1)
% if (numero_redondos_diametro1_dch*(pi*((diametro_1_dch/2)^2)))>Adch
%    if (numero_redondos_diametro1_dch*(pi*((diametro_1_dch/2)^2)))>Adch  
       if Mymax>=Myd 
        
%             Ai4=[[numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup];
%       [numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup];
%       [numero_redondos_diametro2_dch 0 r numero_redondos_diametro1_dch diametro_1_dch ];
%       [numero_redondos_diametro2_dch 0 r numero_redondos_diametro1_dch diametro_1_dch ];
%   ]

% next=sum(Ai4(:,1)); %calcula la suma de los redondos en los extremos
% ncen=sum(Ai4(:,4));%calcula la suma de los redondos intermedios
% na=next+ncen; %suma total de todos los redondos
% v=zeros(na,3); %matriz de ceros de 3 columnas y na filas, 
% %siendo la matriz v=[pos.x pos.y diametro]

%---------------------------







% Matriz_simple4=Ai4;
 Matriz_simple_dch=[[0 0 r numero_redondos_diametro1_dch diametro_1_dch ];
       [0 0 r numero_redondos_diametro1_dch diametro_1_dch ];
   ];

 Ai5=Matriz_simple_dch
 area_simple2=2*(numero_redondos_diametro1_dch)*pi*((diametro_1_dch/2)^2)


      hold on;
     
% 
%         end 

    
      
      %----
       hold on
       numero_redondos_diametro1_dch_final=numero_redondos_diametro1_dch+2;
       Ai2=[[0 0  0 0 0];
      [0 0 0 0 0];
      [0 0 r numero_redondos_diametro1_dch_final diametro_1_dch ];
      [0 0 r numero_redondos_diametro1_dch_final diametro_1_dch ];
  ]
acero=armadura()
       subplot(1,2,1);
        seccion(0.5,b/2+b/5,h/2+h/10);
        
%  text(0,3,'Nred');
%  text(0.9,3,'Diam');
%  text(1.8,3,'r');
%  text(2.10,3,'N red');
%  text(3,3,'Diam');
 subplot(1,2,2);
  top=text(2,1.7,num2str(Matriz_simple_dch),'HorizontalAlignment','center');
 sop = top.FontSize;
 top.FontSize = 16;
 line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4]);
 axis off tight
%clc
   end
    end
             Ai6=[[numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup];
       [numero_redondos_diametro1_sup diametro_1_sup  r numero_redondos_diametro2_sup diametro_2_sup];
       [numero_redondos_diametro2_dch 0 r numero_redondos_diametro1_dch diametro_1_dch ];
       [numero_redondos_diametro2_dch 0 r numero_redondos_diametro1_dch diametro_1_dch ];
   ]
    Matriz_simple_suma= area_simple2+area_simple1
end
clc
end

