
function arm_poligonos_total_v6(Nd, Mxd, Myd, r, re, na, Ai, Asup, Asup2, Asup3, r1)

fck=25;
fyk=500;
fcd=fck/1.5;
fyd=fyk/1.15;
Es=2.0*10^5;


%----------------------------------------------------------------------
armadura_sup()


%Armadura superior - Armadura inferior-------------------------------------

function armadura_sup
%La armadura superior e inferior son iguales

%Parmetros--------------------
 
% Asup=500; %area armadura superior
%x(1)=diametro 1, x(2)=diametro 2, x(3)=n de redondos de diametro 2
%lb = [6 1]; %limites inferiores de x(1), x(2) 
%ub = [40 20]; %limites superiores de x(1), x(2) 
% Como cada conjunto de valores de los diametros tienen 10 miembros
%se debe discretizar en un rango de variables [1 10], por lo que
%los nuevos limites inferiores y superiores quedan de la siguiente forma

lb = [1]; %limites inferiores de x(1), x(2) 
ub = [10]; %limites superiores de x(1), x(2) 
%el limite superior de x(3) determina hasta el n max de redondos a poner

function x = valores_posibles(x)
%Esta funcin crea las variables de los diametrox x(1) y x(2) definiendo 
%sus posibles valores

% Posibles valores para el diametro 1 x(1) y diamatro 2 x(2)
diam1 = [6 8 10 12 14 16 20 25 32 40];

%n_red=1:1:3; %puedo crear una variable que determine hasta que n de
%redondos quiero poner

% Discretiza valores, es decir, cada variable elige su valor a partir del
% vector dado
x(1) = diam1(x(1));
%x(2)=n_red(x(2));% si actuar ka variable en relacion al n max deseado
end

function [c, ceq] = restricciones(x)
%Esta funcion calcula los constraints/restricciones del problema, 
%es decir, son ecuaciones adicionales del problema

%EJEMPLO RESTRICCIONES
%c(1)=2*x(1)-diametro_1_sup;  %diametro_sup_extremos>=2*diametro_lateral 
%c(1)=diametro_1_sup-2*x(1);  %2*x(1)>=diametro_sup_extremos
%--------------------------------------------------------------------

c(1)=Asup-((pi*1*na*(x(1)/2)^2));%el area a obtener debe ser mayor que el 
%area (A) obtenido por los esfuerzos
%c(2)=121-(x(1)*3/na);


ceq = []; %matriz ceq
end

function a = area(x)
%Funcin que determina el valor del area a partir de las 3 variables

a=(1*na*(pi*(x(1)/2)^2)); %area a obtener
end


function a = variables_discretiza(x)

x = valores_posibles(x);% Map de variables discretas

a = area(x); % Area a partir de las variables
end

function [c, ceq] = restricciones_discretiza(x)
%funcion de la matriz de las restricciones

x = valores_posibles(x); % Map variables discretas

[c, ceq] = restricciones(x); %evaluacin de las restricciones
end

%[xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,n de variables, [], [], [], [], lb, ub, @restricciones_discretiza, n de variables que no poseen parametros a elegir, opts);
[xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,1, [], [], [], [], lb, ub, @restricciones_discretiza, 1:1);
area_obtenida_sup=fbestDisc;
xbestDisc = valores_posibles(xbestDisc);%hago la llamda para obtener los diametros
%dentro de los posible valores especificados
diametro_1_sup=xbestDisc(1);
% numero_redondos_diametro1_sup=xbestDisc(2); %n redondos totales en todo el polgono

%area_obtenida_sup_int=3*pi*(diametro_1_sup/2)^2;

r1=r-(re+diametro_1_sup);
r2=r1;

end
%Impresin por pantalla de los datos---------------------------------------
%sobreescribo el area Ai del principio por el nuevo area Ai hallada

% fprintf('Ai=[N redondos Diametro Recubrimiento')
% 
% 
% %num_red_lado=round(3/na); %obligo a que por lado sea un n exacto de redondos
% num_red_lado=1;
% Ai=[[num_red_lado diametro_1_sup re]
%    ]
%  
%-----------------------------------------------------------------
function armadura_sup2

lb = [1]; 
ub = [10]; 


function x = valores_posibles(x)

% Posibles valores para el diametro 1 x(1) y diamatro 2 x(2)
diam1 = [6 8 10 12 14 16 20 25 32 40];

x(1) = diam1(x(1));
%x(2)=n_red(x(2));% si actuar ka variable en relacion al n max deseado
end

function [c, ceq] = restricciones(x)

smin = 20; %mnima separacin entre barras


c(1)=Asup2-((pi*2*na*(x(1)/2)^2));

ceq = []; %matriz ceq
end

function a = area(x)
%Funcin que determina el valor del area a partir de las 3 variables

a=(2*na*(pi*(x(1)/2)^2)); %area a obtener
end

function a = variables_discretiza(x)

x = valores_posibles(x);% Map de variables discretas

a = area(x); % Area a partir de las variables
end

function [c, ceq] = restricciones_discretiza(x)
%funcion de la matriz de las restricciones

x = valores_posibles(x); % Map variables discretas

[c, ceq] = restricciones(x); %evaluacin de las restricciones
end

%[xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,n de variables, [], [], [], [], lb, ub, @restricciones_discretiza, n de variables que no poseen parametros a elegir, opts);
[xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,1, [], [], [], [], lb, ub, @restricciones_discretiza, 1:1);
area_obtenida_sup=fbestDisc;
xbestDisc = valores_posibles(xbestDisc);%hago la llamda para obtener los diametros
%dentro de los posible valores especificados
diametro_1_sup=xbestDisc(1);
% numero_redondos_diametro1_sup=xbestDisc(2); %n redondos totales en todo el polgono

%area_obtenida_sup_int=6*pi*(diametro_1_sup/2)^2;

r1=r-(re+diametro_1_sup);
r2=r1;

end


%------------------------------------------------------------------------
function armadura_sup3

lb = [1];  
ub = [10]; 


function x = valores_posibles(x)

% Posibles valores para el diametro 1 x(1) y diamatro 2 x(2)
diam1 = [6 8 10 12 14 16 20 25 32 40];

x(1) = diam1(x(1));
%x(2)=n_red(x(2));% si actuar ka variable en relacion al n max deseado
end

function [c, ceq] = restricciones(x)


c(1)=Asup3-((pi*3*na*(x(1)/2)^2));

ceq = []; %matriz ceq
end

function a = area(x)
%Funcin que determina el valor del area a partir de las 3 variables

a=(3*na*(pi*(x(1)/2)^2)); %area a obtener
end

function a = variables_discretiza(x)

x = valores_posibles(x);% Map de variables discretas

a = area(x); % Area a partir de las variables
end

function [c, ceq] = restricciones_discretiza(x)
%funcion de la matriz de las restricciones

x = valores_posibles(x); % Map variables discretas

[c, ceq] = restricciones(x); %evaluacin de las restricciones
end

%[xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,n de variables, [], [], [], [], lb, ub, @restricciones_discretiza, n de variables que no poseen parametros a elegir, opts);
[xbestDisc, fbestDisc, exitflagDisc] = ga(@variables_discretiza,1, [], [], [], [], lb, ub, @restricciones_discretiza, 1:1);
area_obtenida_sup=fbestDisc;
xbestDisc = valores_posibles(xbestDisc);%hago la llamda para obtener los diametros
%dentro de los posible valores especificados
diametro_1_sup=xbestDisc(1);
% numero_redondos_diametro1_sup=xbestDisc(2); %n redondos totales en todo el polgono

%area_obtenida_sup_int=9*pi*(diametro_1_sup/2)^2;

r1=r-(re+diametro_1_sup);
r2=r1;

end


%-------------------------------------------------------------------
acero=armadura(na,r);


[Li,Wi]=integraHammer(); % integracion de Hammer
[n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
[nodos,eltos]=discretiza(na,r); % discretizacion area bruta
 
emax=ecu2;

options = optimoptions('fsolve','Display','off');
s0=[0 0 0];
s=fsolve(@(s)calcula(s),s0,options);

vv=esfuerzos(s);
Mxmax=vv(1);
Mymax=vv(2);

    function [Li,Wi]=integraHammer()
        % metode de integracion de Hammer eltos triangulares
        
        Li=1/2*[
            [1 1 0]
            [1 0 1]
            [0 1 1]
            ]; % coordenadas
        Wi=1/6*[1 1 1]; % pesos        
        
    end        

    function [n,ec2,ecu2]=initHormigon(fck)
        % diagrama parabola-rectangulo
        
        if(fck<50)
            n=2;
            ec2=2/1000;
            ecu2=3.5/1000;
        else
            n=1.4+23.4*((90-fck)/100)^4;
            ec2=(2.0+0.085*(fck-50)^0.53)/1000;
            ecu2=(2.6+35*((90-fck)/100)^4)/1000;            
        end
        
    end

    function [nodos,eltos]=discretiza(n,r)
        % discretizacion
        t = (1/(2*n):1/n:1)'*2*pi;
        
        x=[];
        y=[];
        for i=1:4
            x=cat(1,x,r/i*cos(t));
            y=cat(1,y,r/i*sin(t));
        end             

        DT=delaunayTriangulation(x,y); % triangulacion de Delaunay
%         figure;
%         triplot(DT)

        nodos=DT.Points; % nodos
        eltos=DT.ConnectivityList; % elementos
                
    end

    function v=defLong(x,y,s)        
        % plano de deformacion
        % (x,y): coordenadas en la seccion
        % e0: deformacion axial
        % ax: giro en torno al eje x
        % ay: giro en torno al eje y
        
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=e0+ay*x+ax*y;        
    end

    function v=tensionHormigon(x,y,s)
        % tension en el Hormigon
        v=0;
        
        ec=defLong(x,y,s);
        if((ec>0)&&(ec<=ec2))
            v=fcd*(1-(1-ec/ec2)^n);            
        elseif(ec>ec2)
            v=fcd;            
        end
                    
    end

    function v=tensionAcero(x,y,s)
        % tension en el Acero
        v=0;
        
        ec=defLong(x,y,s);
        if(ec<-fyd/Es)
            v=-fyd;
        elseif(-fyd/Es<ec)&&(ec<fyd/Es)
            v=Es*ec;
        else
            v=fyd;
        end
                    
    end

    function v0=calcula(s)
        % calcula e0 para Nd
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=zeros(1,3);
        x=0;
        y=0;
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            vJ=calculaJ(nk);
            v0=intHammer(nk,s);
            v=v+v0*vJ;
        end        
        
        % aportacion del acero
        n0=size(acero);
        n0=n0(1); % numero de armaduras
        for k=1:n0
            x=acero(k,1);
            y=acero(k,2);
            d=acero(k,3);
            A=pi*(d/2)^2; % area
            ts=tensionAcero(x,y,s);
            v=v+A*ts*[1 y x];
        end
        
        v(1)=v(1)/1000; % axil (kN)
        v(2)=v(2)/10^6; % flector Mx (kNm)
        v(3)=v(3)/10^6; % flector My (kNm)
        
        v0=zeros(1,2);
        v0(1)=v(1)-Nd;
        
        v1=ecmax(s);                 
        v0(2)=v1-emax;
        
        v0(3)=v(3)-Myd;
        
    end

    function v0=esfuerzos(s)
        % (Nc,Mc): esfuerzos en el hormign
        e0=s(1);
        ax=s(2);
        ay=s(3);
        
        v=zeros(1,3);
        x=0;
        y=0;
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            vJ=calculaJ(nk);
            v0=intHammer(nk,s);
            v=v+v0*vJ;
        end 
        
        % aportacion del acero
        n0=size(acero);
        n0=n0(1); % numero de armaduras
        for k=1:n0
            x=acero(k,1);
            y=acero(k,2);
            d=acero(k,3);
            A=pi*(d/2)^2; % area
            ts=tensionAcero(x,y,s);
            v=v+A*ts*[1 y x];
        end
        
        v(1)=v(1)/1000; % axil (kN)
        v(2)=v(2)/10^6; % flector Mx (kNm)
        v(3)=v(3)/10^6; % flector My (kNm)
        
        v0=[v(2) v(3)];
        
    end

    function v0=ecmax(s)
        % deformacion maxima en el hormigon
         
        v0=0;       
        n0=size(eltos);
        n0=n0(1); % numero de elementos
        for k=1:n0
            vk=eltos(k,:); % elemento k
            nk=nodos(eltos(k,:),:); % nodos del elemento k
            for j=1:3
                x=nk(j,1);
                y=nk(j,2);
                v0=max(v0,defLong(x,y,s));
            end
        end                
    end

    function vJ=calculaJ(nk)
        % calcula el jacobiano
        % vk: elemento k
        % nk: nodos del elemento k
        vJ=zeros(2);
        vJ(1,1)=[1 0 -1]*nk(:,1);
        vJ(1,2)=[1 0 -1]*nk(:,2);
        
        vJ(2,1)=[0 1 -1]*nk(:,1);
        vJ(2,2)=[0 1 -1]*nk(:,2);
        
        vJ=det(vJ);              
                       
    end

    function v=intHammer(nk,s)
        % coordenadas (x,y) a partir de (L1,L2,L3)
        
        v=zeros(1,3);    
        for i=1:3
                Lj=Li(i,:);
                x=Lj*nk(:,1);
                y=Lj*nk(:,2);
                v=v+Wi(i)*tensionHormigon(x,y,s)*[1 y x];
        end                
    end      

    function v=armadura(n,r)       
                       
        ni=Ai(1,1); % numero de redondos por lado, na=n lados, r=longitud lado
        di=Ai(1,2); % diametro
        ri=Ai(1,3); % recubrimiento mecanico   
        cx=0;cy=0;  
   if ni>=4
       return
           fprintf('\nResultados incompatibles con los parmetros introducidos\n')
  return
   end

        %-------------------------------------------------------------------
%Polgonos de un solo redondos por lado
if ni==1
  clf; %borra las imagenes
hold on;


%Poligono exterior
theta=[0:2*pi/na:2*pi]+pi/2;
x=r*cos(theta)+cx; %me da la coordenada de x de cada pto de un lado del poligono
y=r*sin(theta)+cy; %me da la coordenada de y de cada pto de un lado del poligono
%Poligono interior
theta1=[0:2*pi/(na):2*pi]+pi/2;
x1=r1*cos(theta1)+cx;
y1=r1*sin(theta1)+cy;

v=zeros(ni*na+1,3);
          
v(:,1)=x1; %coordenada en x de cada punto del poligono
v(:,2)=y1; %coordenada en y de cada punto del poligono
v(:,3)=di;
x2=x1; %cambio el nombre de variable porque voy a crear una matriz de na+1 filas y dos columnas
y2=y1;
w=zeros(ni*na+1,2);
w(:,1)=x2;  %coordenada en x de cada punto del poligono
w(:,2)=y2;
%Redondos
for i=1:na+1

ci=w(i,:);
viscircles(ci,di/2);%viscircles(centro,radio)
end

% figure(gcf)
        subplot(1,2,1)
        plot (x,y)
 
title('Armado seccin')
%plot(x,y, x1, y1) %si quiero que se vea tambien el poligono inteiror
 axis('image')
 hold off
% figure('Name','Armado Seccin','NumberTitle','off');
% suptitle('Armado seccin')          
% subplot(1,2,2);
% text(0,3,'Nred')
% text(0.9,3,'Diam')
% 
% top=text(2,2,num2str(Ai),'HorizontalAlignment','center')
% sop = top.FontSize;
% top.FontSize = 16;
% line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
% axis off tight
end

%-----------------------------------------------------------------------
%Triangulo de 2 redondos por lado
if na==3 & ni==2
   clf;
    hold on;
cx=0;cy=0;
 %Poligono exterior-------------------------------------
        theta1=[0:2*pi/na:2*pi]+pi/2;beta=(2*pi)/na;
        x=r*cos(theta1)+cx;
        y=r*sin(theta1)+cy;               
 %Puntos de los redondos-----------------------------   
        alpha=(2*pi)/(na*ni);
        b=(sin(beta))*r1/(sin(pi-beta-alpha/2));
        a=(sin(alpha/2))*r1/(sin(pi-beta-alpha/2));
        h=a*cos(beta);
        n=0;
        m=r1;
        pto1=[n, m] ;
        

        a2=(sin(alpha))*r1/(sin(pi-beta-alpha));
        b2=r1*sin(beta);c2=b2-a;
        h2=c2/tan(beta);
        m2=-r1-h;
        n2=0;
        pto2=[n2, m2]; 
        m3=m2;n3=r1/4;
        m4=m2;n4=-r1/4;
        pto3=[n3, m3];
        pto4=[n4,m4];
        
        m5=r1+h;
        k5=(r1/3)*sin(beta);
        n5=k5;
        pto5=[n5,m5];
        
        m6=r1+2*h;
        k6=(2*r1/3)*sin(beta);
        n6=k6;
        pto6=[n6,m6];
        
        n7=-n5;m7=m5;
        n8=-n6;m8=m6;
        pto7=[n7,m7];
        pto8=[n8,m8];
        
        

        w=zeros(ni*na,2);

        w(:,1)=[n3, n4, n5, n6, n7, n8]; %coordenada en x de cada punto de la recta
        w(:,2)=[m3, m4, m5, m6, m7, m8];%coordenada en y de cada punto  de la recta
        v=zeros(ni*na,3);
        v(:,1)=w(:,1); %coordenada en x de cada punto del poligono
        v(:,2)=w(:,2); %coordenada en y de cada punto del poligono
        v(:,3)=di;
        
     
  %Poligono interior1---------------------------------------------
        x1=r1*cos(theta1)+cx;
        y1=r1*sin(theta1)+cy;
        
        
        figure(gcf)
        subplot(1,2,1)
        plot(x,y)
        title('Armado seccin')
        %plot(x,y, x1, y1, 'r')
        %viscircles(pto1,di)
        %viscircles(pto2,di)
        viscircles(pto3,di/2)
        viscircles(pto4,di/2)
        viscircles(pto5,di/2)
     viscircles(pto6,di/2)
     viscircles(pto7,di/2)
     viscircles(pto8,di/2)
        axis('image')
%         grid
       hold off
%        figure('Name','Armado Seccin','NumberTitle','off');
% suptitle('Armado seccin')          
% subplot(1,2,2);
% text(0,3,'Nred')
% text(0.9,3,'Diam')
% 
% top=text(2,2,num2str(Ai),'HorizontalAlignment','center')
% sop = top.FontSize;
% top.FontSize = 16;
% line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
% axis off tight
end

%------------------------------------------------
%Triangulo de 3 redondos por lado
if na==3 & ni==3
    clf;
    hold on
cx=0;cy=0;
 %Poligono exterior-------------------------------------
        theta1=[0:2*pi/na:2*pi]+pi/2;beta=(2*pi)/na;
        x=r*cos(theta1)+cx;
        y=r*sin(theta1)+cy;               
 %Puntos de los redondos-----------------------------   

%          n=0
%          m=-r1
%          pto1=[n, m]
        
        alpha=(2*pi)/(na*2);
        b=(sin(beta))*r1/(sin(pi-beta-alpha/2));
        a=(sin(alpha/2))*r1/(sin(pi-beta-alpha/2));
        h=a*cos(beta);
        n=0;
        m=r1;
        pto1=[n, m];
        

        a2=(sin(alpha))*r1/(sin(pi-beta-alpha));
        b2=r1*sin(beta);c2=b2-a;
        h2=c2/tan(beta);
        m2=-r1-h;
        n2=0;
        
        pto2=[n2, m2]; %abajo centro
        
        h3=(r1/4)*sin(beta);
        m3=m2;n3=r1/2;
        m4=m2;n4=-r1/2;
        pto3=[n3, m3]; %abajo derecha
        pto4=[n4,m4]; %abajo izquierda
        
        h3=(r1/4)*sin(beta);
        m5=r1-h3;
        k5=sqrt((r1/4)^2-(h3)^2);
        n5=k5;
        pto5=[n5,m5]; %derecha arriba

        
        m6c=r1-3*h3;
        k6c=sqrt((3*r1/4)^2-(3*h3)^2);
        n6c=k6c;
        pto6c=[n6c,m6c];
          
        m10c=r1-6*h3;
        k10c=sqrt((1.5*r1)^2-(6*h3)^2);
        n10c=k10c;
        pto10c=[n10c,m10c];
        
        n7=-n5;m7=m5;
        n7c=-n6c;m7c=m6c;
        n8=-n10c;m8=m10c;
        pto7=[n7,m7];
        pto7c=[n7c,m7c];
        pto8=[n8,m8] ;
        
        w=zeros(ni*na,2);
        w(:,1)=[n2, n3, n4, n5, n6c, n7, n7c, n8, n10c]; %coordenada en x de cada punto de la recta
        w(:,2)=[m2, m3, m4, m5, m6c, m7, m7c, m8, m10c];%coordenada en y de cada punto  de la recta
        v=zeros(ni*na,3);
        v(:,1)=w(:,1); %coordenada en x de cada punto del poligono
        v(:,2)=w(:,2); %coordenada en y de cada punto del poligono
        v(:,3)=di;
        

  %Poligono interior1---------------------------------------------
        x1=r1*cos(theta1)+cx;
        y1=r1*sin(theta1)+cy;
        
        
        figure(gcf)
        subplot(1,2,1)
        plot(x,y)
        title('Armado seccin')
       % plot(x,y, x1, y1, 'r')
%         viscircles(pto1,di)
        viscircles(pto2,di/2)
        viscircles(pto3,di/2)
        viscircles(pto4,di/2)
        viscircles(pto5,di/2)
%       viscircles(pto6,di)
      viscircles(pto6c,di/2)
     viscircles(pto7,di/2)
     viscircles(pto7c,di/2)
     viscircles(pto8,di/2)
%       viscircles(pto9c,di)
      viscircles(pto10c,di/2)
        axis('image')
%         grid
        hold off
%         figure('Name','Armado Seccin','NumberTitle','off');
% suptitle('Armado seccin')          
% subplot(1,2,2);
% text(0,3,'Nred')
% text(0.9,3,'Diam')
% 
% top=text(2,2,num2str(Ai),'HorizontalAlignment','center')
% sop = top.FontSize;
% top.FontSize = 16;
% line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
% axis off tight
end
   
%------------------------------------------------------------------
 %Cuadrado con dos redondos por lado (na=4, ni=2)

if na==4 & ni==2
   clf;
    hold on;
cx=0;cy=0;
 %Poligono exterior-------------------------------------
        theta1=[0:2*pi/na:2*pi];beta=(2*pi)/na;
        x=r*cos(theta1)+cx;
        y=r*sin(theta1)+cy;               
 %Puntos de los redondos-----------------------------   

        n=r1/3;m=2*r1/3;
        pto1=[n, m];
  
        n2=2*r1/3;m2=r1/3;
        pto2=[n2, m2];
        
        n3=2*r1/3;m3=-r1/3;
        pto3=[n3, m3];
        
        n4=r1/3;m4=-2*r1/3;
        pto4=[n4, m4];
        
        n5=-r1/3;m5=2*r1/3;
        pto5=[n5, m5];
  
        n6=-2*r1/3;m6=r1/3;
        pto6=[n6, m6];
        
        n7=-2*r1/3;m7=-r1/3;
        pto7=[n7, m7];
        
        n8=-r1/3;m8=-2*r1/3;
        pto8=[n8, m8];
        
  
        
        w=zeros(ni*na,2);
        w(:,1)=[n, n2, n3, n4, n5, n6, n7, n8]; %coordenada en x de cada punto de la recta
        w(:,2)=[m, m2, m3, m4, m5, m6, m7, m8];%coordenada en y de cada punto  de la recta
        v=zeros(ni*na,3);
        v(:,1)=w(:,1); %coordenada en x de cada punto del poligono
        v(:,2)=w(:,2); %coordenada en y de cada punto del poligono
        v(:,3)=di;
      

  %Poligono interior1---------------------------------------------
        x1=r1*cos(theta1)+cx;
        y1=r1*sin(theta1)+cy;
        
        
        figure(gcf)
        subplot(1,2,1)
        plot(x,y)
        title('Armado seccin')
        %plot(x,y, x1, y1, 'r')
        viscircles(pto1,di/2)
        viscircles(pto2,di/2)
        viscircles(pto3,di/2)
        viscircles(pto4,di/2)
        viscircles(pto5,di/2)
        viscircles(pto6,di/2)
        viscircles(pto7,di/2)
        viscircles(pto8,di/2)
        
        axis('image')
%         grid
        hold off
%         figure('Name','Armado Seccin','NumberTitle','off');
% suptitle('Armado seccin')          
% subplot(1,2,2);
% text(0,3,'Nred')
% text(0.9,3,'Diam')
% 
% top=text(2,2,num2str(Ai),'HorizontalAlignment','center')
% sop = top.FontSize;
% top.FontSize = 16;
% line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
% axis off tight
    
end

%------------------------------------------------------
   %Cuadrado con tres redondos por lado (na=4, ni=3)

if na==4 & ni==3
   clf;
    hold on;

cx=0;cy=0;
 %Poligono exterior-------------------------------------
        theta1=[0:2*pi/na:2*pi];beta=(2*pi)/na;
        x=r*cos(theta1)+cx;
        y=r*sin(theta1)+cy;               
 %Puntos de los redondos-----------------------------   

        n=3*r1/4;m=r1/4;
        pto1=[n, m];
  
        n2=2*r1/4;m2=2*r1/4;
        pto2=[n2, m2];
        
        n3=r1/4;m3=3*r1/4;
        pto3=[n3, m3];
        
        n4=3*r1/4;m4=-r1/4;
        pto4=[n4, m4];
  
        n5=2*r1/4;m5=-2*r1/4;
        pto5=[n5, m5];
        
        n6=r1/4;m6=-3*r1/4;
        pto6=[n6, m6];
        
        n7=-n;m7=m;
        n8=-n2;m8=m2;
        n9=-n3;m9=m3;
        n10=-n4;m10=m4;
        n11=-n5;m11=m5;
        n12=-n6;m12=m6;
        pto7=[n7, m7];
        pto8=[n8,m8];
        pto9=[n9,m9];
        pto10=[n10,m10];
        pto11=[n11,m11];
        pto12=[n12,m12];
        
        w=zeros(ni*na,2);
        w(:,1)=[n, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12]; %coordenada en x de cada punto de la recta
        w(:,2)=[m, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11, m12];%coordenada en y de cada punto  de la recta
        v=zeros(ni*na,3);
        v(:,1)=w(:,1); %coordenada en x de cada punto del poligono
        v(:,2)=w(:,2); %coordenada en y de cada punto del poligono
        v(:,3)=di;
        
  %Poligono interior1---------------------------------------------
        x1=r1*cos(theta1)+cx;
        y1=r1*sin(theta1)+cy;
        
        
        figure(gcf)
        subplot(1,2,1)
        plot(x,y)
        title('Armado seccin')
       % plot(x,y, x1, y1, 'r')
        viscircles(pto1,di/2)
        viscircles(pto2,di/2)
        viscircles(pto3,di/2)
        viscircles(pto4,di/2)
        viscircles(pto5,di/2)
        viscircles(pto6,di/2)
        viscircles(pto7,di/2)
        viscircles(pto8,di/2)
        viscircles(pto9,di/2)
        viscircles(pto10,di/2)
        viscircles(pto11,di/2)
        viscircles(pto12,di/2)
%         
        axis('image')
% %         grid
         hold off
%         figure('Name','Armado Seccin','NumberTitle','off');
% suptitle('Armado seccin')          
% subplot(1,2,2);
% text(0,3,'Nred')
% text(0.9,3,'Diam')
% 
% top=text(2,2,num2str(Ai),'HorizontalAlignment','center')
% sop = top.FontSize;
% top.FontSize = 16;
% line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
% axis off tight
    
end
  
%---------------------------------------------------------------
 %Pentagono con dos redondos por lado (na=5, ni=2)

if na==5 && ni==2
   clf;
    hold on;
cx=0;cy=0;
 %Poligono exterior-------------------------------------
        theta1=[0:2*pi/na:2*pi]+pi/2;beta=(108*2*pi)/360;%108
        omega=(2*pi)/na; %72
        x=r*cos(theta1)+cx;
        y=r*sin(theta1)+cy;  
            
%Puntos de los redondos-----------------------------   
        alpha=(2*pi)/(na*ni);phi=pi-(beta/2)-(omega/3);
        a2=(sin(alpha))*r1/(sin(pi-beta-alpha));
        apot=(r1)/(2*tan(omega/2));
        b=(sin(beta/2))*r1/(sin(phi));
        a=(sin(omega/3))*r1/(sin(phi))   ; 
        h=a*cos(beta/2);
        h1=r1-h;
        m=h1;
        n=a*sin(beta/2);
        
        pto1=[n, m];
        
        h11=r1*cos(omega) ;%coordenada y del vertice derecho
        x11=r1*sin(omega); %coordenada x del vertice derecho

        m2=h11+h;
        n2=x11-n;

        pto2=[n2, m2];
        
        n5=-n2;m5=m2;
        n6=-n;m6=m;
        pto5=[n5, m5]; %arriba izquierda
        pto6=[n6, m6];
        
        u=r*cos(beta/2)-r1*cos(beta/2);
        n7=r1/4;m7=-apot-u+di/2;
        n8=-r1/4;m8=-apot-u+di/2;
        pto7=[n7, m7] ;%abajo 
        pto8=[n8, m8];
      
        h11=r1*cos(omega); %coordenada y del vertice derecho
        x11=r1*sin(omega) ;%coordenada x del vertice derecho
        k11=(r1/3)*sin(beta-omega/2);
        p11=(r1/3)*cos(beta-omega/2);
        m11=h11-k11;
        n11=x11-p11;
        
        pto11=[n11, m11];
        k12=(2*r1/3)*sin(beta-omega/2);
        p12=(2*r1/3)*cos(beta-omega/2);
        m12=h11-k12;
        n12=x11-p12;
        pto12=[n12, m12];
        n13=-n11;m13=m11;
        n14=-n12;m14=m12;
        pto13=[n13,m13];
        pto14=[n14,m14];
        
        w=zeros(ni*na,2);
        w(:,1)=[n, n2, n5, n6, n7, n8, n11, n12, n13, n14]; %coordenada en x de cada punto de la recta
        w(:,2)=[m, m2, m5, m6, m7, m8, m11, m12, m13, m14];%coordenada en y de cada punto  de la recta
        v=zeros(ni*na,3);
        v(:,1)=w(:,1); %coordenada en x de cada punto del poligono
        v(:,2)=w(:,2); %coordenada en y de cada punto del poligono
        v(:,3)=di;
        
   %Poligono interior1---------------------------------------------
        x1=r1*cos(theta1)+cx;
        y1=r1*sin(theta1)+cy;
        
        hold on
        figure(gcf)
        subplot(1,2,1)
        plot (x,y)
%         plot(x,y)
         title('Armado seccin')
       % plot(x,y, x1, y1, 'r')
        viscircles(pto1,di/2)
        viscircles(pto2,di/2)
        viscircles(pto5,di/2)
        viscircles(pto6,di/2)
        viscircles(pto7,di/2)
         viscircles(pto8,di/2)
         viscircles(pto11,di/2)
         viscircles(pto12,di/2)
       viscircles(pto13,di/2)
       viscircles(pto14,di/2)
        axis('image')
%         grid
        hold off;
%         figure('Name','Armado Seccin','NumberTitle','off');
% suptitle('Armado seccin')          
% subplot(1,2,2);
% text(0,3,'Nred')
% text(0.9,3,'Diam')
% 
% top=text(2,2,num2str(Ai),'HorizontalAlignment','center')
% sop = top.FontSize;
% top.FontSize = 16;
% line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
% axis off tight
end


 %----------------------------------------------------------------
 %Pentagono con tres redondos por lado (na=5, ni=3)

if na==5 & ni==3
    clf;
hold on;
cx=0;cy=0;
 %Poligono exterior-------------------------------------
        theta1=[0:2*pi/na:2*pi]+pi/2;beta=(108*2*pi)/360;%108
        omega=(2*pi)/na; %72
        x=r*cos(theta1)+cx;
        y=r*sin(theta1)+cy;               
%Puntos de los redondos-----------------------------   
        alpha=(2*pi)/(na*ni);phi=pi-(beta/2)-(omega/3);
        a2=(sin(alpha))*r1/(sin(pi-beta-alpha));
        apot=(r1)/(2*tan(omega/2));
        b=(sin(beta/2))*r1/(sin(phi));
        a=(sin(omega/4))*r1/(sin(phi))  ;  
        h=a*cos(beta/2);
        h1=r1-h;
        m=h1;
        n=a*sin(beta/2);
        
         pto1=[n, m];
        
        h11=r1*cos(omega); %coordenada y del vertice derecho
        x11=r1*sin(omega); %coordenada x del vertice derecho
        m2=h11+h;
        n2=x11-n;
        m2c=h11+1.875*h;
        n2c=x11-1.875*n;

        
        pto2=[n2, m2];
        pto2c=[n2c, m2c];
        
        n5=-n2;m5=m2;
        n6=-n;m6=m;
        n5c=-n2c;m5c=m2c;
        pto5=[n5, m5] ;%arriba izquierda
        pto6=[n6, m6];
        pto5c=[n5c, m5c];
        
        u=r*cos(beta/2)-r1*cos(beta/2);
        n7=r1/4;m7=-apot-u+di/2;
        n8=-r1/4;m8=-apot-u+di/2;
        n7c=0;m7c=-apot-u+di/2;;
        pto7=[n7, m7] ;%abajo 
        pto7c=[n7c, m7c];
        pto8=[n8, m8];
      
        h11=r1*cos(omega); %coordenada y del vertice derecho
        x11=r1*sin(omega); %coordenada x del vertice derecho
        k11=(r1/4)*sin(beta-omega/2);
        p11=(r1/4)*cos(beta-omega/2);
        m11=h11-k11;
        n11=x11-p11;
        
        pto11=[n11, m11];
        k12=(2*r1/4)*sin(beta-omega/2);
        p12=(2*r1/4)*cos(beta-omega/2);
        m12=h11-k12;
        n12=x11-p12;
        pto12=[n12, m12];
        k12c=(3*r1/4)*sin(beta-omega/2);
        p12c=(3*r1/4)*cos(beta-omega/2);
        m12c=h11-k12c;
        n12c=x11-p12c;
        pto12c=[n12c, m12c];
        
        n13=-n11;m13=m11;
        n13c=-n12c;m13c=m12c;
        n14=-n12;m14=m12;
        pto13=[n13,m13];
        pto14=[n14,m14];
        pto13c=[n13c, m13c];
        
        w=zeros(ni*na,2);
        w(:,1)=[n, n2, n2c, n5, n5c, n6, n7, n7c, n8, n11, n12, n12c, n13, n13c, n14]; %coordenada en x de cada punto de la recta
        w(:,2)=[m, m2, m2c, m5, m5c, m6, m7, m7c, m8, m11, m12, m12c, m13, m13c, m14];%coordenada en y de cada punto  de la recta
        v=zeros(ni*na,3);
        v(:,1)=w(:,1); %coordenada en x de cada punto del poligono
        v(:,2)=w(:,2); %coordenada en y de cada punto del poligono
        v(:,3)=di;
   %Poligono interior1---------------------------------------------
        x1=r1*cos(theta1)+cx;
        y1=r1*sin(theta1)+cy;
        
        hold on
        figure(gcf)
        subplot(1,2,1)
        plot(x,y)
         
        title('Armado seccin')
       % plot(x,y, x1, y1, 'r')
        viscircles(pto1,di/2)
        viscircles(pto2,di/2)
         viscircles(pto2c,di/2)
        viscircles(pto5,di/2)
        viscircles(pto5c,di/2)
        viscircles(pto6,di/2)
        viscircles(pto7,di/2)
        viscircles(pto7c,di/2)
         viscircles(pto8,di/2)
         viscircles(pto11,di/2)
         viscircles(pto12,di/2)
          viscircles(pto12c,di/2)
       viscircles(pto13,di/2)
        viscircles(pto13c,di/2)
       viscircles(pto14,di/2)
        axis('image')
%         grid
        hold off;
%         figure('Name','Armado Seccin','NumberTitle','off');
% suptitle('Armado seccin')          
% subplot(1,2,2);
% text(0,3,'Nred')
% text(0.9,3,'Diam')
% 
% top=text(2,2,num2str(Ai),'HorizontalAlignment','center')
% sop = top.FontSize;
% top.FontSize = 16;
% line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
% axis off tight
end

 %--------------------------------------------------------------
   %Hexgono con dos redondos por lado (na=6, ni=2)

if na==6 & ni==2
 clf;
hold on;

cx=0;cy=0;
 %Poligono exterior-------------------------------------
        theta1=[0:2*pi/na:2*pi]+pi/2;beta=(2*pi)/na;
        x=r*cos(theta1)+cx;
        y=r*sin(theta1)+cy;               
 %Puntos de los redondos-----------------------------   
        alpha=(2*pi)/(na*ni);
        b=(sin(beta))*r1/(sin(pi-beta-alpha/2));
        a=(sin(alpha/2))*r1/(sin(pi-beta-alpha/2));
        h=a*cos(beta);
        n=a*sin(beta);
        m=r1-h;
        pto1=[n, m];
        

        a2=(sin(alpha))*r1/(sin(pi-beta-alpha));
        b2=r1*sin(beta);c2=b2-a;
        h2=c2/tan(beta);
        m2=r1-h2;
        n2=c2;
        pto2=[n2, m2];

        b3=(sin(beta))*r1/(sin(pi-beta-alpha));
        a3=(sin(alpha))*r1/(sin(pi-beta-alpha));
        h3=a2*cos(beta);
        m3=r1/4;
        n3=r1*sin(beta);
        pto3=[n3, m3] ; %centro arriba
       
        n4=n3;m4=-m3;
        pto4=[n4, m4]; %centro abajo
        
        n5=n2;m5=-m2;
        n6=n;m6=-m;
        pto5=[n5, m5]; %abajo derecha
        pto6=[n6, m6];
        
        n7=-n5;m7=m5;
        n8=-n6;m8=m6;
        pto7=[n7, m7] ;%abajo izquierda
        pto8=[n8, m8];
         
        n9=-n3;m9=m3;
        n10=-n4;m10=m4;
        pto9=[n9, m9] ;%centro izq arriba
        pto10=[n10, m10]; %centro izq abajo
        
        n11=-n;m11=m;
        n12=-n2;m12=m2;
        pto11=[n11, m11];
        pto12=[n12, m12];
        
        w=zeros(ni*na,2);
        w(:,1)=[n, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12]; %coordenada en x de cada punto de la recta
        w(:,2)=[m, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11, m12];%coordenada en y de cada punto  de la recta
        v=zeros(ni*na,3);
        v(:,1)=w(:,1); %coordenada en x de cada punto del poligono
        v(:,2)=w(:,2); %coordenada en y de cada punto del poligono
        v(:,3)=di;
  %Poligono interior1---------------------------------------------
        x1=r1*cos(theta1)+cx;
        y1=r1*sin(theta1)+cy;
        
        
        figure(gcf)
        subplot(1,2,1)
        plot(x,y)
        title('Armado seccin')
       % plot(x,y, x1, y1, 'r')
        viscircles(pto1,di/2)
        viscircles(pto2,di/2)
        viscircles(pto3,di/2)
        viscircles(pto4,di/2)
        viscircles(pto5,di/2)
        viscircles(pto6,di/2)
        viscircles(pto7,di/2)
        viscircles(pto8,di/2)
        viscircles(pto9,di/2)
        viscircles(pto10,di/2)
        viscircles(pto11,di/2)
        viscircles(pto12,di/2)
        axis('image')
%         grid
        hold off;
%         figure('Name','Armado Seccin','NumberTitle','off');
% suptitle('Armado seccin')          
% subplot(1,2,2);
% text(0,3,'Nred')
% text(0.9,3,'Diam')
% 
% top=text(2,2,num2str(Ai),'HorizontalAlignment','center')
% sop = top.FontSize;
% top.FontSize = 16;
% line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
% axis off tight
    
   end

%--------------------------------------------------------------
   %Hexgono con tres redondos por lado (na=6, ni=3)

if na==6 & ni==3
   clf;
hold on;

cx=0;cy=0;
 %Poligono exterior
        theta1=[0:2*pi/na:2*pi]+pi/2;beta=(2*pi)/na;
        x=r*cos(theta1)+cx;
        y=r*sin(theta1)+cy;               
%Puntos de los redondos-----------------------------          
        alpha=(2*pi)/(na*ni);
        b=(sin(beta))*r1/(sin(pi-beta-alpha/2));
        a=(sin(alpha/2))*r1/(sin(pi-beta-alpha/2));
        h=a*cos(beta);
        n=a*sin(beta);
        m=r1-h;
        pto1=[n, m];
        
        a2=(sin(alpha))*r1/(sin(pi-beta-alpha));
        b2=r1*sin(beta);c2=b2-a;
        h2=c2/tan(beta);
        m2=r1-h2;
        n2=c2;
        pto2=[n2, m2];
        
        b2c=(r1*sin(beta))/2;
        h2c=b2c/tan(beta);
        m2c=r1-h2c;
        n2c=b2c;
        pto2c=[n2c, m2c];

        b3=(sin(beta))*r1/(sin(pi-beta-alpha));
        a3=(sin(alpha))*r1/(sin(pi-beta-alpha));
        h3=a2*cos(beta);
        m3=r1/4;
        n3=r1*sin(beta);
        pto3=[n3, m3] ; %centro arriba
       
        n4=n3;m4=-m3;
        pto4=[n4, m4]; %centro abajo
        
        n3c=n3;m3c=0;
        pto3c=[n3c,m3c];
        
        n5=n2;m5=-m2;
        n6=n;m6=-m;
        n5c=n2c;m5c=-m2c;
        pto5=[n5, m5]; %abajo derecha
        pto6=[n6, m6];
        pto5c=[n5c, m5c];
        n7=-n5;m7=m5;
        n8=-n6;m8=m6;
        n7c=-n5c;m7c=m5c;
        
        pto7=[n7, m7]; %abajo izquierda
        pto8=[n8, m8];
        pto7c=[n7c, m7c];
        
         
        n9=-n3;m9=m3;
        n10=-n4;m10=m4;
        n9c=-n3c;m9c=m3c;
        pto9=[n9, m9]; %centro izq arriba
        pto10=[n10, m10]; %centro izq abajo
        pto9c=[n9c, m9c];
        
        n11=-n;m11=m;
        n12=-n2;m12=m2;
        n11c=-n2c;m11c=m2c;
        pto11=[n11, m11];
        pto12=[n12, m12];
        pto11c=[n11c, m11c];
        
        w=zeros(ni*na,2);
        w(:,1)=[n, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12,  n2c, n3c, n5c, n7c,n11c, n9c]; %coordenada en x de cada punto de la recta
        w(:,2)=[m, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11, m12,  m2c, m3c, m5c, m7c,m11c, m9c];%coordenada en y de cada punto  de la recta
        v=zeros(ni*na,3);
        v(:,1)=w(:,1); %coordenada en x de cada punto del poligono
        v(:,2)=w(:,2); %coordenada en y de cada punto del poligono
        v(:,3)=di;
 
%Poligono interior1
        x1=r1*cos(theta1)+cx;
        y1=r1*sin(theta1)+cy;
        
        
        figure(gcf)
        subplot(1,2,1)
        plot(x,y)
        title('Armado seccin')
       % plot(x,y, x1, y1, 'r')
        viscircles(pto1,di/2)
        viscircles(pto2,di/2)
        viscircles(pto3,di/2)
        viscircles(pto4,di/2)
        viscircles(pto5,di/2)
        viscircles(pto6,di/2)
        viscircles(pto7,di/2)
        viscircles(pto8,di/2)
        viscircles(pto9,di/2)
        viscircles(pto10,di/2)
        viscircles(pto11,di/2)
        viscircles(pto12,di/2)
        viscircles(pto2c,di/2)
        viscircles(pto3c,di/2)
        viscircles(pto5c,di/2)
        viscircles(pto7c,di/2)
        viscircles(pto11c,di/2)
        viscircles(pto9c,di/2)
        axis('image')
%         grid
        hold off;
%         figure('Name','Armado Seccin','NumberTitle','off');
% suptitle('Armado seccin')          
% subplot(1,2,2);
% text(0,3,'Nred')
% text(0.9,3,'Diam')
% 
% top=text(2,2,num2str(Ai),'HorizontalAlignment','center')
% sop = top.FontSize;
% top.FontSize = 16;
% line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
% axis off tight
        
end
%----------------------------------
    end
   if na==20
       figure('Name','Atencin','NumberTitle','off');
      tope2=text(0.2,2.4,'Debe elegir Resultado - Seccin Circular.')
      tope3=text(0.2,2.6,'Reinicia el programa con otro parmetros.')
        top=text(2,2,string(''),'HorizontalAlignment','center')
   tope2.FontSize = 14; 
   tope3.FontSize = 14; 
  line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
  close('Opcion_2');
       return
   end
%-------------------------------------------------------------------


while Mxmax<Mxd & Ai(1,1)==1 & na~=20; %while Mxmax<Mxd || Mymax<Myd
  
    
   Asup=Asup+50;
 
armadura_sup()



acero=armadura(na,r);
[Li,Wi]=integraHammer(); % integracion de Hammer
[n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
[nodos,eltos]=discretiza(na,r); % discretizacion area bruta

options = optimoptions('fsolve','Display','off');
s0=[0 0 0];
s=fsolve(@(s)calcula(s),s0,options);

vv=esfuerzos(s);
Mxmax=vv(1);
Mymax=vv(2);

% if(Mxmax>Mxd)
%     clc;
%     
%     X = sprintf('%f > %f',Mxmax,Mxd);
%     clc;
%     fprintf('Mxmax>Mxd\n')
%     disp(X)
%         disp("Cumple con los requisitos introducidos")
%        disp("[N redondos Diametro Recubrimiento]")
%  W=sprintf('[%f %f %f]', Ai(1,1), diametro_1_sup, re);
%          disp(W);
%           
% else
%     disp("No Cumple con los requisitos introducidos")
%     clf;
% 
%     clc;
%     %X = sprintf('%f < %f',Mxmax,Mxd)
% end
%----------------------------------------------
if diametro_1_sup==25 & Ai(1,1)==1 & Mxmax<Mxd 
    Ai(1,1)=2

    fprintf('Recalculando parmetros\n')
    
   
while Mxmax<Mxd & Ai(1,1)==2;
     Asup2=Asup2+50; %empiezo con el area inicial
armadura_sup2()

%Impresin por pantalla de los datos---------------------------------------
%sobreescribo el area Ai del principio por el nuevo area Ai hallada

fprintf('Ai=[N redondos Diametro Recubrimiento]')


 Ai=[[2 diametro_1_sup re]
    ]

acero=armadura(na,r);
[Li,Wi]=integraHammer(); % integracion de Hammer
[n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
[nodos,eltos]=discretiza(na,r); % discretizacion area bruta

options = optimoptions('fsolve','Display','off');
s0=[0 0 0];
s=fsolve(@(s)calcula(s),s0,options);

vv=esfuerzos(s);
Mxmax=vv(1);
Mymax=vv(2);

if(Mxmax>Mxd)
    clc;
   
    X = sprintf('%f > %f',Mxmax,Mxd);
    clc;
    fprintf('Mxmax>Mxd\n')
   disp(X)
       disp("Cumple con los requisitos introducidos")
       disp("[N redondos Diametro Recubrimiento]")
       W=sprintf('[%f %f %f]', Ai(1,1), diametro_1_sup, re);
         disp(W);
          
else
    disp("No Cumple con los requisitos introducidos")
    clf;

    clc;
  
end


%------
if diametro_1_sup==32 & Ai(1,1)==2 & Mxmax<Mxd 
    Ai(1,1)=3

    fprintf('Recalculando parmetros\n')
    
   
while Mxmax<Mxd & Ai(1,1)==3;
    Asup3=Asup3+50; %empiezo con el area inicial

armadura_sup3()

%Impresin por pantalla de los datos---------------------------------------
%sobreescribo el area Ai del principio por el nuevo area Ai hallada

fprintf('Ai=[N redondos Diametro Recubrimiento]')


 Ai=[[3 diametro_1_sup re]
    ]

acero=armadura(na,r);
[Li,Wi]=integraHammer(); % integracion de Hammer
[n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
[nodos,eltos]=discretiza(na,r); % discretizacion area bruta

options = optimoptions('fsolve','Display','off');
s0=[0 0 0];
s=fsolve(@(s)calcula(s),s0,options);

vv=esfuerzos(s);
Mxmax=vv(1);
Mymax=vv(2);

if(Mxmax>Mxd)
    clc;
   
    X = sprintf('%f > %f',Mxmax,Mxd);
    clc;
     fprintf('Mxmax>Mxd\n')
    disp(X)
       disp("Cumple con los requisitos introducidos")
       disp("[N redondos Diametro Recubrimiento]")
        W=sprintf('[%f %f %f]', Ai(1,1), diametro_1_sup, re);
        disp(W);
        
else

    fprintf('No Cumple con los requisitos introducidosn')
    clf;
%     figure('Name','Error','NumberTitle','off');
%  title('Error')
%  whitebg('r')
%  
%  tope2=text(0.2,2.4,'No cumple con los requisitos introducidos')
%  top=text(2,2,string(''),'HorizontalAlignment','center')
%   tope2.FontSize = 12; 
%  line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
%  axis off tight
    clc;
  

armadura_sup3()

%Impresin por pantalla de los datos---------------------------------------
%sobreescribo el area Ai del principio por el nuevo area Ai hallada

fprintf('Ai=[N redondos Diametro Recubrimiento]')


 Ai=[[3 diametro_1_sup re]
    ]

acero=armadura(na,r);
[Li,Wi]=integraHammer(); % integracion de Hammer
[n,ec2,ecu2]=initHormigon(fck); % diagrama parabola-rectangulo Hormigon
[nodos,eltos]=discretiza(na,r); % discretizacion area bruta

options = optimoptions('fsolve','Display','off');
s0=[0 0 0];
s=fsolve(@(s)calcula(s),s0,options);

vv=esfuerzos(s);
Mxmax=vv(1);
Mymax=vv(2);

if(Mxmax>Mxd)
    clc;
    
   X = sprintf('%f > %f',Mxmax,Mxd);
   clc;
     fprintf('Mxmax>Mxd\n')
    disp(X)
        disp("Cumple con los requisitos introducidos")
       disp("[N redondos Diametro Recubrimiento]")
         W=sprintf('[%f %f %f]', Ai(1,1), diametro_1_sup, re);
         disp(W);
        
   
else
    disp("No Cumple con los requisitos introducidos")
    clf;

    clc;
   
end


end
    

 if Mxmax<Mxd & Mymax<Myd & diametro_1_sup==40 & Ai(1,1)==3;
     clc;
%     clf;
figure('Name','Atencin','NumberTitle','off');
      tope2=text(0.2,2.4,'No cumple con los requisitos introducidos.')
      tope3=text(0.2,2.6,'Reinicia el programa con otro parmetros.')
        top=text(2,2,string(''),'HorizontalAlignment','center')
   tope2.FontSize = 14; 
   tope3.FontSize = 14; 
  line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
%     disp("Reinicia el programa con otros valores.")
     return
 end

end

end
end
end
end
% figure('Name','Matriz Armado Seccin','NumberTitle','off');
suptitle('Armado Seccin')          
 subplot(1,2,2);
text(0,3,'Nredondos')
text(1.3,3,'Dimetro')
text(2.4,3,'recubrimiento')

top=text(1.8,2,num2str(Ai),'HorizontalAlignment','center')
sop = top.FontSize;
top.FontSize = 20;
line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
axis off tight
  top=text(1.8,2,num2str(Ai),'HorizontalAlignment','center')%
 sop = top.FontSize;
  top.FontSize = 20;
  line([.25 0 0 .25 NaN 3.75 4 4 3.75],[0 0 4 4 NaN 0 0 4 4])
  axis off tight
   top4=text(0.65,1, 'rea armado (mm^2)');
   Apoligono=Ai(1)*na*pi*((Ai(2)/2)^2);
   top5=text(1.95,0.65,num2str(Apoligono),'HorizontalAlignment','center');
    sop5 = top5.FontSize;
    top5.FontSize = 16;
     sop4 = top4.FontSize;
    top4.FontSize = 12;

clc
end
